<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerCleanup extends jvideodirectController
{
	function __construct() {
		parent::__construct();
	}
	
	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect( JRoute::_('index.php?option=com_jvideodirect'), $msg );
	}

	function cleandb() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$model =& $this->getModel( 'Cleanup' );
		$result =& $model->cleandatabase();
		if ($result) {
			$msg = JText::_('Database has been cleaned up successfully.');
			$msgtype = null;
		} else {
			$msg = JText::_('Failed to clean up database');
			$msgtype = 'error';		
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=cleanup', $msg, $msgtype);	
	}

	function cleanbuffer() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$model =& $this->getModel( 'Cleanup' );
		$result =& $model->cleanbuffer();
		if ($result) {
			$msg = JText::_('Buffer folder has been cleaned up successfully.');
			$msgtype = null;
		} else {
			$msg = JText::_('Failed to clean up Buffer folder');
			$msgtype = 'error';		
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=cleanup', $msg, $msgtype);		
	}
}
?>
