<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerPlugins extends jvideodirectController
{
	function __construct() {
		parent::__construct();
	}
	
	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jvideodirect', $msg );
	}

	function deleteplugins() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$cids = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cids, array());

		if(count($cids)) {
			$model =& $this->getModel( 'Plugins' );
			$cid = implode(',',$cids);
			$ret =& $model->deletePlugin($cid);		
			if ($ret == true){
				$msg = JText::_('UNINSTALLSUCCESS'); $msgtype = '';
			} else {
				$msg = JText::_('UNINSTALLFAIL'); $msgtype = 'error';
			}
		}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=plugins', $msg, $msgtype);			
	}

	function publish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}
		$model = $this->getModel('plugins');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=plugins');
	}


	function unpublish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}
		$model = $this->getModel('plugins');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=plugins');
	}

	function ftpsubmit() {
		$rows = array();
		$rows['ftpusername'] = JRequest::getVar( 'ftpusername', null);
		$rows['ftppassword'] = JRequest::getVar( 'ftppassword', null);
		$config = new JConfig;
		jimport('joomla.client.helper');
		if (($rows['ftpusername'] != null) || ($rows['ftppassword'])) {
			if (($config->ftp_enable == true) && (JClientHelper::setCredentialsFromRequest('ftp') == true)) {
				if (!JClientHelper::setCredentials('ftp',$rows['ftpusername'], $rows['ftppassword'])){
					$msg = JText::_( 'ftp credentials cannot be set.' );	
					$msgtype = 'error';				
				}
			}
		} else {
			$msg = JText::_( 'Please fill in ftp credentials.' );	
			$msgtype = 'error';
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=plugins', $msg, $msgtype);		
	}

	function installPlugins() {	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		jimport( 'joomla.filesystem.archive' );		
		$file = JRequest::getVar( 'pluginFile', null, 'files', 'array');

		if ($file['tmp_name']) { 	
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
			$tmpDir = JPath::clean( JPATH_SITE.DS.'media' );
			$filename = viewTools::randomcode(10);
			$ext = JFile::getExt($file['name']);
			$file_ext = $filename.'.'.$ext;
				
			if (JFile::upload($file['tmp_name'], $tmpDir.DS.$file_ext )) {	
				if (JFolder::create($tmpDir.DS.$filename)) {
					if (JArchive::extract($tmpDir.DS.$file_ext, $tmpDir.DS.$filename)) {
						$model =& $this->getModel( 'Plugins' );
						$install =& $model->installPlugin($tmpDir.DS.$filename, $ext);	
						if ($install != false) {
							$msg = JText::_('INSTALLSUCCESS').' Plugin: '.$install;$msgtype = '';
						}
					} else { $msg = JText::_('Error: Failed to extract file to "media/'.$filename.'" folder.');$msgtype = 'error';}
				} else { $msg = JText::_('Error: Failed to create folder in "media" folder.');$msgtype = 'error';}
			}
		} else { $msg = JText::_('PLEASESELECTFILE');$msgtype = 'error';}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=plugins', $msg, $msgtype);		
	}
	
	
	
}
?>
