<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerVideomanagement extends jvideodirectController
{
	function __construct() {
		parent::__construct();
	}
	
	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect('index.php?option=com_jvideodirect', $msg );
	}
	
	function cancelbu() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement', $msg );
	}	

	function batchupdateform() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());	
		if(count($cid)) {
			$cids = implode(',', $cid);
			$session =& JFactory::getSession();
			$session->clear('bucid');
			$session->set('bucid', $cids);		
			$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement&layout=batchupdate');
		}	
	}

	function batchupdate() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$db =& JFactory::getDBO();
		$cids = JRequest::getVar( 'cids', '' );
		$flag = false;
		if ($cids) {
			$p = " SET";
			if (JRequest::getVar( 'bu_feature' )) {
				$p .= " featured = '" . (int) JRequest::getVar( 'bu_feature_to' )."',";$flag = true;}
			if (JRequest::getVar( 'bu_approval' )) {
				$p .= " published = '" . (int) JRequest::getVar( 'bu_approval_to' )."',";$flag = true;}
			if (JRequest::getVar( 'bu_checked' )) {
				$p .= " checked = '" . (int) JRequest::getVar( 'bu_checked_to' )."',";$flag = true;}
			if (JRequest::getVar( 'bu_access' )) {
				$p .= " accesstype = '" . (int) JRequest::getVar( 'bu_access_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_category' )) {
				$p .= " catid = '" . (int) JRequest::getVar( 'bu_category_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_totalviews' )) {
				$p .= " totalviews = '" . (int) JRequest::getVar( 'bu_totalviews_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_totalvotes' )) {
				$p .= " totalvotes = '" . (int) JRequest::getVar( 'bu_totalvotes_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_totalratings' )) {
				$p .= " totalratings = '" . (int) JRequest::getVar( 'bu_totalratings_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_allow_comments' )) {
				$p .= " allow_comments = '" . (int) JRequest::getVar( 'bu_allow_comments_to' )."',";$flag = true;}
			if (JRequest::getVar( 'bu_allow_embedding' )) {
				$p .= " allow_embedding = '" . (int) JRequest::getVar( 'bu_allow_embedding_to' )."',";$flag = true;}				
			if (JRequest::getVar( 'bu_allow_ratings' )) {
				$p .= " allow_ratings = '" . (int) JRequest::getVar( 'bu_allow_ratings_to' )."',";$flag = true;}				
			if ($flag == true) {	
			$q = 'UPDATE #__dv_videos' . substr($p, 0, -1) . ' WHERE id IN ( '.$cids.' )';
			$db->setQuery($q);
				if (!$db->query()) {
					$msg = $db->getErrorMsg();
					$msgtype = "error";
				} else {
					$msg = 'Successfully updated.';
					$msgtype = '';
				}
			} else {
				$msg = "No action is selected";
				$msgtype = "error";				
			}
		} else {
			$msg = "No action is selected";
			$msgtype = "error";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement', $msg,$msgtype);			
	}

	function deleteVideo() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());
		$db =& JFactory::getDBO();
		if(count($cid)) {
			jimport('joomla.filesystem.folder');
			jimport('joomla.filesystem.file');
			jimport('joomla.filesystem.path');					
			$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos';
			for ($j=0;$j<count($cid);$j++) {
				usleep(500000); /*0.5sec*/ 
				$q = 'SELECT * FROM #__dv_videos WHERE id = "'.$cid[$j].'"';
				$db->setQuery( $q );
				$vdo = $db->loadObject();
				$files = array(0 => $base.DS.'pics'.DS.'small'.DS.$vdo->vid.'.jpg',
					  $base.DS.'pics'.DS.'small2'.DS.$vdo->vid.'.jpg',
					  $base.DS.'pics'.DS.'medium'.DS.$vdo->vid.'.jpg',
					  $base.DS.'hd'.DS.$vdo->userid.DS.$vdo->vid.'.mp4',
					  $base.DS.'hd'.DS.$vdo->userid.DS.$vdo->vid.'.mp4.flv',
					  $base.DS.'sd'.DS.$vdo->userid.DS.$vdo->vid.'.flv',
					  $base.DS.'ipad'.DS.$vdo->userid.DS.$vdo->vid.'.m4v',
					  $base.DS.'org'.DS.$vdo->userid.DS.$vdo->vid.'.'.$vdo->ext);	
				for ($i=0;$i<count($files);$i++) {
					if (JFile::exists($files[$i])){JFile::delete($files[$i]);}
				}
			}
			$cids = implode( ',', $cid );
			$query = "DELETE FROM #__dv_videos WHERE id IN ( $cids )";
			$db->setQuery( $query );	
			if ($db->query()){
				$query = "DELETE FROM #__dv_uchannelsitems WHERE vid IN ( $cids )";
				$db->setQuery( $query );	
				if ($db->query()){
					$query = "DELETE FROM #__dv_ugroupsitems WHERE vid IN ( $cids )";
					$db->setQuery( $query );	
					if ($db->query()){						
						$query = "DELETE FROM #__dv_playlistitems WHERE vid IN ( $cids )";
						$db->setQuery( $query );
						if ($db->query()){								
							$query = "DELETE FROM #__dv_favorites WHERE vid IN ( $cids )";
							$db->setQuery( $query );
							if ($db->query()){						
								$msg = JText::_('DV_ADM_V_SUCC_DEL');
								$msgtype = '';						
							} else { $msg = JText::_('DV_ADM_ERROR_CATDEL'); $msgtype = 'error';}
						} else { $msg = JText::_('DV_ADM_ERROR_CATDEL'); $msgtype = 'error';}
					} else { $msg = JText::_('DV_ADM_ERROR_CATDEL'); $msgtype = 'error';}			
				} else { $msg = JText::_('DV_ADM_ERROR_CATDEL'); $msgtype = 'error';}
			} else { $msg = JText::_('DV_ADM_ERROR_CATDEL'); $msgtype = 'error';}
		}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement', $msg, $msgtype);	
	}

	function recoverIt() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$id = JRequest::getVar( 'video', '' );	
		$db = &JFactory::getDBO();		
		$query = 'UPDATE #__dv_videos'
				. ' SET log = 0 WHERE id ="'.$id.'"';
		$db->setQuery( $query );
		if($db->query()) {
			$msg = JText::_('DV_ADM_VIDEO_RECOVERED');
			$msgtype = '';
		} else {
			$msg = JText::_('DV_ADM_VIDEO_RECOVEREDFAIL');
			$msgtype = 'error';				
		}		
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement', $msg,$msgtype);	
	}

	function saveVideo() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');
		require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');
		$flag = false;
		$id = JRequest::getVar( 'video', '' );	
		$cat = JRequest::getVar( 'category', '');
		$dur = JRequest::getVar( 'duration', '');		
		$tnt = JRequest::getVar( 'tntime', '' );		
		$row = JRequest::get('post');
		$tnf = JRequest::getVar( 'tnsrcfile', null, 'files', 'array');	
		$model =& $this->getModel( 'Videomanagement' );
		if ($tnt) {
			if (preg_match("(^[0-5][0-9]:[0-5][0-9]$)", $tnt)) {
				$ret =& $model->newThumb($id, $tnt);
				if ($ret['ok']) {
					$flag = true;
				} else {
					JError::raiseWarning( 500, 'Thumbnail generation error.');
				}
			} else { JError::raiseWarning( 500, 'Thumbnail image extraction time format is invalid.'); }
		}	
		if ($tnf['error'] == 0) {
			$fileExt = strtolower(jFile::getExt ($tnf['name']));
			if (($fileExt == 'png')||($fileExt == 'jpg')||($fileExt == 'gif')) {			
				$ret =& $model->newThumbm($id, $tnf, true);
				if ($ret['ok']) {
					$flag = true;
				} else {
					if (isset($ret['msg'])) {
						JError::raiseWarning( 500, $ret['msg']);
					} else {
						JError::raiseWarning( 500, 'Thumbnail generation error.');					
					}
				}
			} else {$msg = JText::_('Only gif, png, jpg format is supported'); $msgtype = 'error';JError::raiseWarning( 500, $msg);}	
		}
		$db = &JFactory::getDBO();
		$row['title'] = $db->getEscaped(viewTools::cleantext($row['title'],false));	
		$row['description'] = $db->getEscaped(viewTools::cleantext($row['description'],false));
		$row['tags'] = $db->getEscaped(viewTools::cleantext($row['tags'],false));
		$tags = helperTools::filtersymbol($row['tags'], true);
		$strs = explode(',', $tags);
		$str = array();
		for ($i=0;$i<count($strs);$i++) {
			if (!empty($strs[$i])) {
				$str[] = trim($strs[$i]);
			}
		}
		$row['tags'] = implode(', ', $str);			
		$row['loc_record'] = $db->getEscaped(viewTools::cleantext($row['loc_record'],false));	
		$durs = explode(':', $dur);
		if ($len[2]) {
			$dur = $durs[0] * 3600 + $durs[1] * 60 + $durs[2];
		} elseif ($durs[1]) {
			$dur = $durs[0] * 60 + $durs[1];
		} else {
			$dur = $durs[0];			
		}			 
		$row['vlength'] = viewTools::sec2hms($dur);
		if (($row['catid'] == 'select')) { $row['catid'] = $cat; }
		$data =& $model->saveCData($row, 'dv_videos', $id);	
		if($data) {
			$msg = ($flag) ? 'Video details are saved and thumbnail image is successfully changed (if new thumbnail image is not reflected, please refresh page)' : JText::_('DV_ADM_VIDEO_SUCC_SAVE');
			$msgtype = '';
		} else {
			$msg = JText::_('DV_ADM_VIDEO_FAIL_SAVE');
			$msgtype = 'error';				
		}		
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement', $msg,$msgtype);	
	}

	function publish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to approve' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}


	function unpublish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unapprove' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}

	function feature() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to feature' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->feature($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}


	function unfeature() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unfeature' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->feature($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}
	
	function check() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to check' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->check($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}


	function uncheck() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to uncheck' ) );
		}
		$model = $this->getModel('videomanagement');
		if(!$model->check($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
	}	
}
?>
