CREATE TABLE IF NOT EXISTS `#__dv_categories` (
  `id` int(50) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `description` text NOT NULL,
  `image` varchar(255) NOT NULL,
  `parent_id` int(50) NOT NULL DEFAULT '0',
  `user_id` varchar(20) NOT NULL DEFAULT '0',
  `groups` int(50) NOT NULL DEFAULT '0',
  `ordering` int(50) NOT NULL DEFAULT '0',
  `featured` tinyint(1) NOT NULL DEFAULT '0',
  `editor` tinyint(1) NOT NULL DEFAULT '0',
  `accesstype` tinyint(1) NOT NULL DEFAULT '1',
  `date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `remark` text NOT NULL,  
  PRIMARY KEY (`id`),
  FULLTEXT KEY `name` (`name`,`description`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT IGNORE INTO `#__dv_categories` (`id`, `name`, `description`, `image`, `parent_id`, `user_id`, `groups`, `ordering`, `featured`, `editor`, `accesstype`, `date_added`, `published`, `remark`) VALUES
(1, 'jVideoDirect', 'This is a sample category.', '', 0, '62', 0, 0, 0, 0, 1, '2009-10-06 09:52:03', 1, '');

CREATE TABLE IF NOT EXISTS `#__dv_channels` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `cid` int(11) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `comment` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_favorites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `gid` int(11) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_log_abuse` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `comment` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_log_ratings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_playlist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `playlist` text NOT NULL,
  `unique` varchar(255) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_playlistitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `playlist` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `order` int(11) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL,
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__dv_plugins`;

CREATE TABLE IF NOT EXISTS `#__dv_plugins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `data` varchar(100) NOT NULL,
  `type` varchar(100) NOT NULL,
  `method` varchar(255) NOT NULL,
  `version` varchar(10) NOT NULL,
  `author` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `website` varchar(255) NOT NULL,
  `remark` varchar(255) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5;

INSERT IGNORE INTO `#__dv_plugins` (`id`, `name`, `data`, `type`, `method`, `version`, `author`, `email`, `website`, `remark`, `published`) VALUES 
('2', 'JW Flv Player', 'jwflvplayer', 'player', '', '', 'jVideoDirect.com', 'cs@jvideodirect.com', 'www.jvideodirect.com', 'longtailvideo.com', '1'),
('3', 'Vcastr', 'vcastr', 'player', '', '', 'jVideoDirect.com', 'cs@jvideodirect.com', 'www.jvideodirect.com', '0', '1'),
('4', 'YouTube', 'youtube', 'grabber', 'link', '', 'jVideoDirect.com', 'cs@jvideodirect.com', 'www.jvideodirect.com', '0', '1'),
('5', 'Google', 'google', 'grabber', 'link', '', 'jVideoDirect.com', 'cs@jvideodirect.com', 'www.jvideodirect.com', '0', '1');

CREATE TABLE IF NOT EXISTS `#__dv_settings` (
  `id` int(50) NOT NULL AUTO_INCREMENT,
  `key` varchar(250) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(50) NOT NULL,
  `default` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=174;

INSERT IGNORE INTO `#__dv_settings` (`id`, `key`, `value`, `type`, `default`) VALUES
('1', 'uploadMech', '1', 'data', '1'),
('2', 'ubruploadpl', '/cgi-bin/ubr_upload.pl', 'data', '/cgi-bin/ubr_upload.pl'),
('3', 'showAllowExt', '1', 'data', '1'),
('4', '_3gp', '1', 'extension', '1'),
('5', 'asf', '1', 'extension', '1'),
('6', 'avi', '1', 'extension', '1'),
('7', 'divx', '1', 'extension', '1'),
('8', 'flv', '1', 'extension', '1'),
('9', 'mp4', '1', 'extension', '1'),
('10', 'mpg', '1', 'extension', '1'),
('11', 'mpeg', '1', 'extension', '1'),
('12', 'mov', '1', 'extension', '1'),
('13', 'moov', '1', 'extension', '1'),
('14', 'rm', '1', 'extension', '1'),
('15', 'rmvb', '1', 'extension', '1'),
('16', 'pathToPhp', '', 'data', ''),
('17', 'vob', '1', 'extension', '1'),
('18', 'wmv', '1', 'extension', '1'),
('19', 'showMaxSize', '1', 'data', '1'),
('20', 'maxFileSize', '10', 'data', '200'),
('21', 'commentSys', '0', 'data', '0'),
('22', 'barColorPl', 'blue', 'data', 'blue'),
('23', 'showUpNote', '1', 'data', '1'),
('24', 'upTitleColor', 'blue', 'data', 'blue'),
('25', 'maxFileSizeByte', '10485760', 'data', ''),
('26', 'sdvfs', '426', 'data', '426'),
('27', 'pathToMplayer', '', 'data', ''),
('28', 'encodePriority', '2', 'data', '2'),
('29', 'pathToFfmpeg', '', 'data', ''),
('30', 'pathToMencoder', '', 'data', ''),
('31', 'pathToFlvtool2', '', 'data', ''),
('32', 'availQuality', '3', 'data', '3'),
('33', 'keepOrgFile', '0', 'data', '1'),
('34', 'sdvbr', '600', 'data', '400'),
('35', 'sdabr', '128', 'data', '128'),
('36', 'sdasr', '44100', 'data', '44100'),
('37', 'hdvbr', '500', 'data', '500'),
('38', 'hdvfs', '480', 'data', '480'),
('39', 'hdabr', '128', 'data', '128'),
('40', 'hdasr', '44100', 'data', '44100'),
('41', 'ar', '1', 'data', '1'),
('42', 'vNeedApproval', '0', 'data', '0'),
('43', 'playThumb', '1', 'data', '1'),
('44', 'playThumbPos', '5', 'data', '5'),
('45', 'playThumbOpt', '1', 'data', '1'),
('46', 'thumbPos', '10', 'data', '10'),
('47', 'pathToWget', '', 'data', ''),
('48', 'converterCall', '1', 'data', '1'),
('49', 'convertFlv', '1', 'data', '1'),
('50', 'itemsDetailDisplay', '3', 'data', '5'),
('51', 's_random', '1', 'sort', '0'),
('52', 's_featured', '1', 'sort', '1'),
('53', 's_hdAvail', '1', 'sort', '1'),
('54', 's_recent', '1', 'sort', '1'),
('55', 's_popular', '1', 'sort', '1'),
('56', 's_hrate', '1', 'sort', '1'),
('57', 's_mostvote', '0', 'sort', '0'),
('58', 's_mostcomment', '0', 'sort', '0'),
('59', 's_hrateO', '4', 'sortO', '4'),
('60', 's_popularO', '3', 'sortO', '3'),
('61', 's_recentO', '2', 'sortO', '2'),
('62', 's_hdAvailO', '5', 'sortO', '5'),
('63', 's_featuredO', '1', 'sortO', '1'),
('64', 's_randomO', '8', 'sortO', '8'),
('65', 's_mostvoteO', '6', 'sortO', '6'),
('66', 's_mostcommentO', '7', 'sortO', '7'),
('67', 'thumbWidthS', '120', 'data', '120'),
('68', 'thumbWidthL', '550', 'data', '320'),
('69', 'widthdl', '550', 'data', '550'),
('70', 'showAdvScroller', '1', 'data', '1'),
('71', 'widthas', '440', 'data', '488'),
('72', 'pageSizeas', '4', 'data', '4'),
('73', 'sortListas', '4', 'data', '5'),
('74', 'noVideoas', '30', 'data', '30'),
('75', 'showTitleas', '1', 'data', '1'),
('76', 's_lastwatched', '0', 'sort', '0'),
('77', 'autoscrollas', '0', 'data', '0'),
('78', 'scrollSpeedas', '2000', 'data', '2000'),
('79', 's_favorites', '0', 'sort', '0'),
('80', 's_favoritesO', '9', 'sortO', '9'),
('81', 'adsolution', '1', 'data','1'),
('82', 'adsolutionD', '', 'data',''),
('83', 'adsolutionS', '', 'data',''),
('84', 's_lastwatchedO', '10', 'sortO', '10'),
('85', 'adsolutionC', '', 'data',''),
('86', 'categoryDL', 'all', 'data', 'all'),
('87', 'adsolutionV', '', 'data',''),
('88', 'categoryAS', 'all', 'data', 'all'),
('89', 'flvplayer', 'jwflvplayer', 'data', 'jwflvplayer'),
('90', 'playerlogo', '1', 'data', '1'),
('91', 'allowEmbed', '1', 'data', '0'),
('92', 'playerautostart', '1', 'data', '1'),
('93', 'playerstretch', '2', 'data', '2'),
('94', 'playerrecommend', '0', 'data', '1'),
('95', 'playerRecommendOp', '1', 'data', '1'),
('96', 'jwflvVer', '2', 'data', '2'),
('97', 'playerwidth', '580', 'data', '550'),
('98', 'playerheight', '282', 'data', '300'),
('99', 'addthis', '1', 'data', '1'),
('100', 'hdiconcolor', '2', 'data', '1'),
('101', 'addthisId', '', 'data', ''),
('102', 'maxChannel', '99999', 'data', '5'),
('103', 'maxGroup', '99999', 'data', '5'),
('104', 'sortingleading', '2', 'data', '3'),
('105', 'sortingintro', '4', 'data', '6'),
('106', 'sortingsec', '0', 'data', '10'),
('107', 'gwidthdl', '550', 'data', '550'),
('108', 'gleading', '2', '4', '4'),
('109', 'gintro', '2', '8', '8'),
('110', 'g_featured', '1', 'gsort', '1'),
('111', 'g_recent', '1', 'gsort', '1'),
('112', 'g_popular', '1', 'gsort', '1'),
('113', 'g_vcount', '1', 'gsort', '1'),
('114', 'g_private', '1', 'gsort', '1'),
('115', 'g_featuredO', '2', 'gsortO', '1'),
('116', 'g_recentO', '1', 'gsortO', '2'),
('117', 'g_popularO', '3', 'gsortO', '3'),
('118', 'g_vcountO', '4', 'gsortO', '4'),
('119', 'g_privateO', '5', 'gsortO', '5'),
('120', 'g_random', '1', 'gsort', '1'),
('121', 'g_randomO', '6', 'gsortO', '6'),
('122', 'secretkey', '', 'data', 'jVideoDirect00Oc1ROrVUAI'),
('123', 'cwidthdl', '550', 'data', '550'),
('124', 'cleading', '2', 'data', '4'),
('125', 'cintro', '1', 'data', '8'),
('126', 'c_featured', '1', 'csort', '1'),
('127', 'c_recent', '1', 'csort', '1'),
('128', 'c_popular', '1', 'csort', '1'),
('129', 'c_vcount', '1', 'csort', '1'),
('130', 'c_private', '1', 'csort', '1'),
('131', 'c_featuredO', '3', 'csortO', '1'),
('132', 'c_recentO', '2', 'csortO', '2'),
('133', 'c_popularO', '1', 'csortO', '3'),
('134', 'c_vcountO', '4', 'csortO', '4'),
('135', 'c_privateO', '5', 'csortO', '5'),
('136', 'c_random', '1', 'csort', '1'),
('137', 'c_randomO', '6', 'csortO', '6'),
('138', 'communitySys', '0', 'data', '0'),
('139', 'js_as_uploadvideo', '1', 'data', '1'),
('140', 'js_as_deletevideo', '1', 'data', '1'),
('141', 'js_as_favvideo', '1', 'data', '1'),
('142', 'js_as_ratevideo', '1', 'data', '1'),
('143', 'js_as_subchannel', '1', 'data', '1'),
('144', 'js_as_unsubchannel', '1', 'data', '1'),
('145', 'js_as_kickoutchannel', '1', 'data', '1'),
('146', 'js_as_joingroup', '1', 'data', '1'),
('147', 'js_as_leavegroup', '1', 'data', '1'),
('148', 'js_as_kickoutgroup', '1', 'data', '1'),
('149', 'js_as_assigngroup', '1', 'data', '1'),
('150', 'js_userpoint', '1', 'data', '1'),
('151', 'js_as_creatchannel', '1', 'data', '1'),
('152', 'js_as_creatgroup', '1', 'data', '1'),
('153', 'js_as_addvchannel', '1', 'data', '1'),
('154', 'js_as_playlistaddvideo', '1', 'data', '1'),
('155', 'js_as_playlistdelvideo', '0', 'data', '0'),
('156', 'js_as_group_feature', '1', 'data', '1'),
('157', 'js_as_channel_feature', '1', 'data', '1'),
('158', 'js_as_video_feature', '1', 'data', '1'),
('159', 'js_as_group_unfeature', '0', 'data', '0'),
('160', 'js_as_channel_unfeature', '0', 'data', '0'),
('161', 'js_as_video_unfeature', '0', 'data', '0'),
('162', 'minPermaChannel', '5', 'data', '5'),
('163', 'minPermaGroup', '5', 'data', '5'),
('164', 'permaChannelReserved', '', 'data', ''),
('165', 'permaGroupReserved', '', 'data', ''),
('166', 'fetchType', '1', 'data', '1'),
('167', 'loginlink', 'index.php?option=com_user', 'data', 'index.php?option=com_user'),
('168', 'credit', '1', 'data', '1'),
('169', 'playemdedinjw', '0', 'data', '1'),
('170', 'fetchlinkonly', '1', 'data', '0'),
('171', 'hdiconoffset', '17', 'data', '0'),
('172', 'pathToFaststart', '', 'data', ''),
('173', 'jwskin', '', 'data', ''),
('174', 'ph_desc', '1', 'data', '1'),
('175', 'ph_tags', '1', 'data', '1'),
('176', 'ph_avatar', '1', 'data', '1'),
('177', 'ph_channellist', '1', 'data', '1'),
('178', 'ph_report', '1', 'data', '1'),
('179', 'ph_votecount', '1', 'data', '1'),
('180', 'ph_access', '1', 'data', '1'),
('181', 'ph_viewscount', '1', 'data', '1'),
('182', 'ph_favcount', '1', 'data', '1'),
('183', 'ph_playlistcount', '1', 'data', '1'),
('184', 'ph_channelsubcount', '1', 'data', '1'),
('185', 'ph_rateitlink', '1', 'data', '1'),
('186', 'ph_favlink', '1', 'data', '1'),
('187', 'ph_directlink', '1', 'data', '1'),
('188', 'ph_subchannellink', '1', 'data', '1'),
('189', 'ph_playlistlink', '1', 'data', '1'),
('190', 'ph_commentitlink', '1', 'data', '1'),
('191', 'ph_comment', '1', 'data', '1'),
('192', 'sefinstalled', '0', 'data', '0'),
('194', 'loadjqnoconflict', '1', 'data', '1'),
('195', 'theme', 'default', 'data', 'default'),
('196', 'ph_title_trim', '27', 'data', '27'),
('197', 'ph_desc_trim', '300', 'data', '300'),
('198', 'ph_tags_max', '10', 'data', '10'),
('199', 'ph_download', '0', 'data', '0'),
('200', 'regonlyplayback', '0', 'data', '0'),
('201', 'storageType', '0', 'data', '0'),
('202', 'as3bucket', '', 'data', ''),
('203', 'as3access', '', 'data', ''),
('204', 'as3secret', '', 'data', ''),
('205', 'roundedcorner', '0', 'data', '0'),
('206', 'rcradius', '10', 'data', '10'),
('207', 'rctopleft', '1', 'data', '1'),
('208', 'rctopright', '1', 'data', '1'),
('209', 'rcbottomleft', '1', 'data', '1'),
('210', 'rcbottomright', '1', 'data', '1'),
('211', 'searchvtag', '1', 'data', '1'),
('212', 'jwplayerstretch', '2', 'data', '2'), 
('213', 'fplayerstretch', '1', 'data', '1'),
('238', 'dbversion', '', 'db', ''),
('260', 'm4v', '1', 'extension', '1');

CREATE TABLE IF NOT EXISTS `#__dv_uchannels` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `unique` varchar(255) NOT NULL,
  `channel` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `access_type` tinyint(4) NOT NULL,
  `pwd` varchar(255) NOT NULL DEFAULT '',
  `image` varchar(255) NOT NULL DEFAULT '0',
  `subscribers` int(11) NOT NULL DEFAULT '0',
  `featured` tinyint(4) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  `status` varchar(255) NOT NULL DEFAULT 'active',
  `acount` int(11) NOT NULL DEFAULT '0',
  `reason` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_uchannelsitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `cid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_ugroups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `unique` varchar(255) NOT NULL,
  `group` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `access_type` tinyint(4) NOT NULL DEFAULT '1',
  `pwd` varchar(50) NOT NULL,
  `image` varchar(255) NOT NULL DEFAULT '0',
  `subscribers` int(11) NOT NULL DEFAULT '0',
  `featured` tinyint(4) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  `status` varchar(255) NOT NULL DEFAULT 'active',
  `acount` int(11) NOT NULL DEFAULT '0',
  `reason` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_ugroupsitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `gid` int(11) NOT NULL,
  `vid` int(11) NOT NULL,
  `type` tinyint(4) NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__dv_videos` (
  `id` int(50) NOT NULL AUTO_INCREMENT,
  `userid` int(50) NOT NULL,
  `vid_type` varchar(10) NOT NULL,
  `vname` varchar(20) NOT NULL,
  `vid` varchar(100) NOT NULL,
  `ext` varchar(10) NOT NULL,
  `title` text NOT NULL,
  `description` text NOT NULL,
  `tags` text NOT NULL,
  `loc_record` text NOT NULL,
  `loc_x` varchar(250) DEFAULT '0', 
  `catid` int(50) DEFAULT '0',
  `sd_w` int(10) NOT NULL DEFAULT '426',
  `sd_h` int(10) NOT NULL DEFAULT '240',
  `hd_w` int(10) NOT NULL DEFAULT '852',
  `hd_h` int(10) NOT NULL DEFAULT '480',
  `vlength` varchar(250) NOT NULL DEFAULT '0',
  `totalviews` int(50) NOT NULL DEFAULT '0',
  `totalvotes` int(50) NOT NULL DEFAULT '0',
  `totalratings` int(50) NOT NULL DEFAULT '0',
  `totalcomments` int(50) NOT NULL DEFAULT '0',
  `totalfavorites` int(50) NOT NULL DEFAULT '0',
  `totalabuse` int(50) NOT NULL DEFAULT '0',
  `totalplaylist` int(50) NOT NULL DEFAULT '0',
  `totalshared` int(50) NOT NULL DEFAULT '0',
  `accesstype` tinyint(1) NOT NULL DEFAULT '1',
  `hd` tinyint(1) NOT NULL DEFAULT '0',
  `featured` tinyint(1) NOT NULL DEFAULT '0',
  `editor` tinyint(1) NOT NULL DEFAULT '0',
  `allow_comments` tinyint(1) NOT NULL DEFAULT '0',
  `allow_embedding` tinyint(1) NOT NULL DEFAULT '0',
  `allow_ratings` tinyint(1) NOT NULL DEFAULT '0',
  `dateadded` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastwatched` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` varchar(30) DEFAULT NULL,
  `try` int(10) NOT NULL DEFAULT '0',
  `checked` tinyint(1) NOT NULL DEFAULT '0',
  `checkeddate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `log` tinyint(4) NOT NULL DEFAULT '0',
  `logdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`),
  FULLTEXT KEY `title` (`title`,`tags`,`description`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
