<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelCategory extends JModel
{
	function __construct(){
		parent::__construct();
		global $mainframe, $option;
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'cat'.'filter_order', 'filter_order','date_added',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'cat'.'filter_order_Dir',	'filter_order_Dir',	'DESC',	'word' );		
		$limit	= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);		
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);	
		if ($cid) {	
			$this->_id = $cid[0];	
		}	
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = "SELECT * FROM #__dv_categories ORDER BY published DESC,ordering ASC ";
			$this->_total = $this->_getListCount($query);
			
		}

		return $this->_total;
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function getData() {
		if (empty($this->_data)) {
			$query = "SELECT * FROM #__dv_categories ORDER BY ". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}

	function getOrder() {
		$lists['order_Dir'] = $this->getState('filter_order_Dir');
		$lists['order'] = $this->getState('filter_order');
		return $lists;
	}
	
	function saveCData($data, $table, $id=0) {
		$row =& JTable::getInstance($table, 'Table');		
		if (!$id == 0) {
			$row->load($id);
			}
		
		if (!$row->bind($data)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		return true;
	}

	function publish($cid = array(), $publish = 1) {	
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__dv_categories'
				. ' SET published = '.(int) $publish
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	function feature($cid = array(), $feature = 1) {	
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__dv_categories'
				. ' SET featured = '.(int) $feature
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	function move($direction) {
		$row =& JTable::getInstance('dv_categories', 'Table');		
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->move( $direction )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}

	function saveorder($cid = array(), $order) {
		$row =& JTable::getInstance('dv_categories', 'Table');	
		for( $i=0; $i < count($cid); $i++ ) {
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}
		return true;
	}

    function processImage ($file, $id) {
        
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');
		$temp = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'temp'.DS.$file['name'];
    	$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'categories'; 		
		$filename = $this->randomcode(10);
    	$dest = $base.DS.$filename.'.png';

    	$ret=array();
 		$src = $file['tmp_name'];   
 		if ($src != null) {
			if (!JFolder::exists($base)) {JFolder::create($base);}
			if (JFile::upload($src, $temp)) {			
				$fileExt = strtolower(jFile::getExt ($file['name']));	
				switch ( $fileExt ) {
					case 'gif':    $img = imagecreatefromgif( $temp );     break;
					case 'jpg':    $img = imagecreatefromjpeg( $temp );    break;
					case 'png':    $img = imagecreatefrompng( $temp );     break;
					default: $ret[1] = 'error'; break;
				} 		
				$width = imagesx( $img );
				$height = imagesy( $img );
				$percentage = 1;
				$percentage = ($width > $height) ? (100 / $height) : (100/ $width);
				$new_width = round($width * $percentage);
				$new_height = round($height * $percentage);
				$tmp_img = imagecreatetruecolor( $new_width, $new_height );				
				if (($fileExt == 'gif') || ($fileExt == 'png')) {
					imagealphablending($tmp_img, false);
					imagesavealpha($tmp_img,true);
					$transparent = imagecolorallocatealpha($tmp_img, 255, 255, 255, 127);
					imagefilledrectangle($tmp_img, 0, 0, $new_width, $new_height, $transparent);
				}
				imagecopyresampled( $tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height );
				imagepng( $tmp_img, $dest, 5, PNG_ALL_FILTERS );
				imagedestroy($tmp_img); 
				imagedestroy($img);				
				JFile::delete($temp);
				$ret[0] = $filename; $ret[1] = true;
	  		} else {$ret[1] = 'error';}
		} else {$ret[1] = 'error';}
		return $ret;
    }	
    
	function randomcode($length) {
		$random= "";
		srand((double)microtime()*1000000);
		$data = "AbcDE123IJKLMN67QRSTUVWXYZ";
		$data .= "aBCdefghijklmn123opq45rs67tuv89wxyz";
		$data .= "0FGH45OP89";
		for($i = 0; $i < $length; $i++) {
			$random .= substr($data, (rand()%(strlen($data))), 1);
		}
		return $random;
	}    
}
?>
