<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelConfig extends JModel
{
	function __construct(){
		parent::__construct();
	}
	
	function createConfigFile() {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		$extArray = $this->getAllowExt();
		$ext = array(); $return = true;
		for ($i=0;$i<count($extArray);$i++) {
			if (substr($extArray[$i]->key, 0, 1) == '_'){
				$extArray[$i]->key = substr($extArray[$i]->key, 1, strlen($extArray[$i]->key)-1);
			}
			$ext[] = $extArray[$i]->key;
		}
		$extPl = '(' . implode($ext,"|") . ')';	
		$extSwf = '*.' . implode($ext,"; *.");	
		$extGe = implode($ext, ", ");

		$configFile = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php';
		JPath::setPermissions($configFile, '0777');
		$config = "<?php\n";
		$config .= "class initjVideoDirect {\n";
		$config .= "    var \$noExtra = null;\n";
		$db =& JFactory::getDBO();
		$q = "SELECT * FROM #__dv_settings";
		$db->setQuery( $q );
		$rows = $db->loadObjectList(); 
		for ($i=0;$i<count($rows);$i++) {
			$config .= "    var \$" . $rows[$i]->key . " = '" . $rows[$i]->value . "';\n";
		}
		$config .= "    var \$extGe = '" . $extGe . "';\n";
		$config .= "    var \$extSwf = '" . $extSwf . "';\n";
		$config .= "    var \$extPl = '" . $extPl . "';\n";
		$config .= "	var \$jurl = '".JURI::root()."';\n";
		$config .= "	var \$jpath = '".JPATH_ROOT."';\n";		
		$config .= "\n    function get_instance() {\n";
		$config .= "        \$noExtra = new initjVideoDirect;\n";
		$config .= "        return \$noExtra;\n";
		$config .= "    }\n";
		$config .= "}\n";
		$config .= "?>\n";

		if (JFile::write($configFile, $config)) {
			JPath::setPermissions($configFile, '0644');
		} else {			
			$controller = new jvideodirectController();
			$controller->setRedirect('index.php?option=com_jvideodirect&view=config', JText::_('DV_ADM_ERROR_FILE_NO_CREATED'), 'error');
			$controller->redirect();
			$return = false;
		}

		return $return;
	}
	
	function getConfigDB() {
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_settings';
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 
		return $ret;
	}
	
	function getExtArray() {
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_settings WHERE type = "extension" ORDER BY `key` ASC';
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 
		return $ret;
	}	

	function getAllowExt() {
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_settings WHERE type = "extension" and value = "1" ORDER BY `key` ASC';
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 
		return $ret;
	}

	function filterConfig ($post) {	
		$config = $this->getConfigDB();
		$ret = array();		
		$ext = array();
		for ($i=0;$i<count($post['allowExtChecked']);$i++){
			$ext[$post['allowExtChecked'][$i]] = 1;
		}
		for ($i=0;$i<count($config);$i++) {
			$ret['key'][$i] = $config[$i]->key;
			if ($config[$i]->type == 'extension') {
				if ($ext[$config[$i]->key] == 1) {
					$ret['value'][$i] = 1;
				} else {
					$ret['value'][$i] = 0;
				}			
			} else {
				$ret['value'][$i] = $post[$config[$i]->key];
			}
		}
		return $ret;    
	}
	
	function storeConfig ($post) {
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('dv_settings', 'Table');
		for($i=0;$i<count($post['key']);$i++) {
			$row->default = '';
			$q = "SELECT * FROM #__dv_settings WHERE `key` = '".$post['key'][$i]."'";
			$db->setQuery( $q );
			$chk = $db->loadObject();
			$row->load($chk->id);
			if ($chk->id == null) {$row->type = 'data';$row->key = $post['key'][$i];}
			if ($post['key'][$i] == 'maxFileSize') {
				$sysMax = @ini_get( 'upload_max_filesize' );
				$systemMax = substr($sysMax,0,strlen($sysMax)-1);
				if (strtolower(substr($sysMax,-1)) == 'k'){
				$systemMax = $systemMax / 1000;}
				$row->default = $systemMax;
			}
			if ($post['key'][$i] == 'secretkey') {
				if ($chk->value == null) {
					$post['value'][$i] = $this->getsecretkey();
				}
			}			
			$row->value = $post['value'][$i];
			if (!$row->store())
			{
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				exit();
			}		
		}		
		return true;
	}

	function checkcomponent($com) {
		$db =& JFactory::getDBO();
		$q = "SELECT * FROM #__components WHERE `option` = 'com_".$com."'";
		$db->setQuery( $q );
		$c = $db->loadObjectList();
		$ret = (count($c)) ? true : false;		
		return $ret;
	}
	
	function getCat() {
		$db =& JFactory::getDBO();
		$q = "SELECT * FROM #__dv_categories WHERE published = '1'";
		$db->setQuery( $q );
		$c = $db->loadObjectList();
		return $c;
	}
		
	function getPlayers() {
		$db =& JFactory::getDBO();
		$q = "SELECT * FROM #__dv_plugins WHERE type = 'player' AND published = '1'";
		$db->setQuery( $q );
		$c = $db->loadObjectList();
		return $c;	
	}
	
	function getsecretkey()	{
		$salt = "jVideoDirect00";
		srand((double)microtime()*1000000);
		$data = "AbcDE123IJKLMN67QRSTUVWXYZ";
		$data .= "aBCdefghijklmn123opq45rs67tuv89wxyz";
		$data .= "0FGH45OP89";
		for($i = 0; $i < 10; $i++) {
			$salt .= substr($data, (rand()%(strlen($data))), 1);
		}
		return $salt;	
	}
	
}
?>
