<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelPlugins extends JModel
{
	function __construct(){
		parent::__construct();
		global $mainframe, $option;
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'p'.'filter_order', 'filter_order','type',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'p'.'filter_order_Dir',	'filter_order_Dir',	'',	'word' );		
		$limit	= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);		
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);	
		if ($cid) {	
			$this->_id = $cid[0];	
		}			
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = "SELECT * FROM #__dv_plugins ";
			$this->_total = $this->_getListCount($query);
			
		}
		return $this->_total;
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function getData() {
		if (empty($this->_data)) {
			$query = "SELECT * FROM #__dv_plugins ORDER BY ". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	
	function getOrder() {
		$lists['order_Dir'] = $this->getState('filter_order_Dir');
		$lists['order'] = $this->getState('filter_order');
		return $lists;
	}
	
	function saveCData($data, $table, $id=0) {
		$row =& JTable::getInstance($table, 'Table');		
		if (!$id == 0) {
			$row->load($id);
			}
		
		if (!$row->bind($data)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		return true;
	}

	function publish($cid = array(), $publish = 1) {	
		if (count( $cid )) {

			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__dv_plugins'
				. ' SET published = '.(int) $publish
				. ' ' .$date. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	function installPlugin($spath, $ext) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		$ret = false; $xmlfile = false; $errflag = false;
		$dpath = JPath::clean( JPATH_SITE.DS.'components'.DS.'com_jvideodirect'.DS.'plugins' );
		if (JFolder::exists($spath)) {
			$files = JFolder::files($spath);
			for($i=0;$i<count($files);$i++) {
				if (strtolower(JFile::getExt($files[$i])) == 'xml') {
					$xmlfile = $files[$i];
				}
			}
			if ($xmlfile != false) {
				$xml = new JSimpleXML;
				$xml->loadFile($spath.DS.$xmlfile);			
				$rootattr = $xml->document->attributes();
				if (($xml->document->name() == 'jvdinstall') && ($rootattr['type'] == 'plugin')) {
					$xmlfiles = $xml->document->files[0]->filename;
					$folder = $xmlfiles[0]->attributes();
					if (JFolder::create($dpath.DS.$folder['plugin'])) {
						for($i=0;$i<count($xmlfiles);$i++) {		
							if (JFile::exists($spath.DS.$xmlfiles[$i]->data())) {
								if (!JFile::copy($spath.DS.$xmlfiles[$i]->data(), $dpath.DS.$folder['plugin'].DS.$xmlfiles[$i]->data())) {
									$errflag = true;
								}
							} else { JError::raiseWarning( 500, $xmlfiles[$i]->data().' cannot be found.'); }
						} 
						if (JFile::exists($spath.DS.$xmlfile)) {
							if (!JFile::move($spath.DS.$xmlfile, $dpath.DS.$folder['plugin'].DS.$xmlfile)) { $errflag = true; }		
						} else { JError::raiseWarning( 500, $xmlfile.' cannot be found.'); }
						if ($errflag == false) {
							$datas = $xml->document->children();
							$d = new stdClass();
							for($i=0;$i<count($datas);$i++) {
								if ($datas[$i]->name() == 'name') {$d->name = $datas[$i]->data();}
								if ($datas[$i]->name() == 'description') {$d->description = $datas[$i]->data();}
								if ($datas[$i]->name() == 'type') {$d->type = $datas[$i]->data();}
								if ($datas[$i]->name() == 'method') {$d->method = $datas[$i]->data();}
								if ($datas[$i]->name() == 'version') {$d->version = $datas[$i]->data();}
								if ($datas[$i]->name() == 'author') {$d->author = $datas[$i]->data();}
								if ($datas[$i]->name() == 'email') {$d->email = $datas[$i]->data();}
								if ($datas[$i]->name() == 'website') {$d->website = $datas[$i]->data();}
								if ($datas[$i]->name() == 'remark') {$d->remark = $datas[$i]->data();}
							}
							$d->data = $folder['plugin'];
							$d->published = 1;		
							if ($this->savePluginToDB($d)) {
								$ret = $d->description;
								$this->cleanup($spath, $ext);
							} else {
								$message = 'Database cannot be accessed.';
								JError::raiseWarning( 500, $message);}
						} else {
							$message = 'Files cannot be moved to plugin/'.$folder['plugin'].' folder.';
							JError::raiseWarning( 500, $message);}														
					} else {
						$message = 'Plugin folder cannot be created.';
						JError::raiseWarning( 500, $message);}														
				} else {	
					$message = 'This is not a jVideoDirect plugin package.';
					JError::raiseWarning( 500, $message);}				
			} else {
				$message = 'Cannot locate xml installation file.';
				JError::raiseWarning( 500, $message);}
		}
		return $ret;
	}
	
	function savePluginToDB($d) {
		$db =& $this->getDBO(); 
		$db->setQuery('SELECT * FROM #__dv_plugins WHERE `data`="'.$d->data.'"');
		$p = $db->loadObject();		
		if (isset($p->id)) {	
			$db->setQuery('DELETE FROM #__dv_plugins WHERE `id`="'. $p->id .'"');
			$db->query();
		}
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tables');
		$new =& JTable::getInstance('dv_plugins', 'Table');		
		if ($new->bind($d)) {
			if ($new->store()) {			
				$ret = true;
			} else { $ret = false;}		
		} 			
		return $ret;
	}
	
	function cleanup($srcfolder, $ext) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		$files = JFolder::files($srcfolder);
		if (count($files)) {
			for($i=0;$i<count($files);$i++) {
				JFile::delete($srcfolder.DS.$files[$i]);
			}
		}
		JFile::delete($srcfolder.'.'.$ext);
		JFolder::delete($srcfolder);
	}
	
	function deletePlugin($cid) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tables');
		$ret = true; 
		$dpath = JPath::clean( JPATH_SITE.DS.'components'.DS.'com_jvideodirect'.DS.'plugins' );
		$db =& $this->getDBO();	
		$cids = explode(',',$cid);
		$total = count($cids);
		for($i=0;$i<$total;$i++) {	
			$row =& JTable::getInstance('dv_plugins', 'Table');	
			$row->load($cids[$i]);			
			$db->setQuery('SELECT * FROM #__dv_plugins WHERE `id`="'. $cids[$i] .'"');
			$row = $db->loadObject();
			switch ($row->data) {
				case 'jwflvplayer':
				case 'vcastr':			
				case 'youtube':
				case 'google':
					$msg = $row->data.' '.JText::_('CANNOTREMOVECORE');
					JError::raiseWarning( 500, $msg);
					$ret = false;
				break;
				default:	
					$delfolder = $dpath.DS.$row->data;
					$files = JFolder::files($delfolder);
					if (count($files)) {
						for($j=0;$j<count($files);$j++) {
							if (!JFile::delete($delfolder.DS.$files[$j])) {
								$msg = $row->data.' plugin file(s) cannot be removed.';
								JError::raiseWarning( 500, $msg);
								$ret = false;								
							}
						}
					}		
					if (!JFolder::delete($delfolder)) {
						$msg = $row->data.' plugin folder(s) cannot be removed.';
						JError::raiseWarning( 500, $msg);
						$ret = false;						
					}
					$db->setQuery('DELETE FROM #__dv_plugins WHERE `data`="'. $row->data .'"');
					if (!$db->query()) {
						$msg = 'Database cannot be updated.';
						JError::raiseWarning( 500, $msg);
						$ret = false;						
					}
				break;
			}
		}
		return $ret;
	}	
}
?>
