<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class jvideodirectModelUserpanel extends JModel
{
	var $_total = null;
	var $_pagination = null;  

   		
	function __construct()
	{
		parent::__construct();	
	}

	function setPagination($type = '1') {
        global $mainframe;
        $config = JFactory::getConfig();
        // Get the pagination request variables        
        $limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit'.$type, '5', 'int' ); 
        $limitstart = $mainframe->getUserStateFromRequest( 'jvideodirect.limitstart'.$type, 'limitstart', 0, 'int' );
        $limitstart = JRequest::getVar('limitstart',0);  

        // In case limit has been changed, adjust limitstart accordingly
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit'.$type, $limit);
        $this->setState('limitstart'.$type, $limitstart);		
    }

	function getPagination($uid, $type = '1', $other = '0') {
		require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');	
		$this->setPagination($type);
		$var = '_pagination'.$type;
		if (empty($this->$var)) {
			// import the pagination library
			jimport('joomla.html.pagination');
			// prepare the pagination values
			$total = $this->getTotal($uid, $type, $other);
			$limitstart = $this->getState('limitstart'.$type);
			$limit = $this->getState('limit'.$type);			
			// create the pagination object
//			$this->$var = new JPagination($total, $limitstart, $limit);
			$this->$var = helperTools::pagination('userpanel', 'userpanel', $total, $limitstart, $limit, 'jobuser', true);
			$pageNav = $this->$var;
			}						
						
		return $pageNav;
	}
	
	function getTotal($uid, $type = '1', $other = '0') {

		$var = '_total'.$type;
		if (empty($this->$var)) {
			switch($type) {
				case '1': $list = helperTools::getVideoListDetails($uid); break;
				case '2': $list = helperTools::getVideoListDetails($uid,'','','','','','',0,2); break;		
				case '3': $list = $this->getPlaylistVideos($uid); break;		
				case '4': $list = $this->getUserSubChannel($uid); break;
				case '6': $list = $this->getsubchannelvideo($uid); break;
				case '7': $list = $this->getUserMyChannel($uid); break;
				case '8': $list = $this->getMyChannelVideo($uid); break;
				case '9': $list = $this->getjoinedgroups($uid); break;
				case '10': $list = $this->getUserMyGroups($uid); break;
			//	case '11': $list = $this->getjoingroupsvideo($uid); break;
				case '12': $list = $this->getMyGroupVideo($uid, $other[0], $other[1]); break;				
				case '13': $list = $this->getgmembers($uid); break;
				case '14': $list = $this->getcmembers($uid); break;				
			}
			
			$this->$var = count($list);
		}
		return $this->$var;
	}

	function getUserPlaylist($id) {
	
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_playlist WHERE uid = "'.$id.'"';
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 		

		return $ret;	
	}

	function getPlaylistVideos($id, $limitstart='', $limit='') {
		$db =& JFactory::getDBO();
		$q = 'SELECT v.*, p.order, p.id as pid FROM #__dv_videos as v, #__dv_playlistitems as p WHERE p.playlist = "'.$id.'" AND p.vid = v.id AND v.log = "0" ORDER BY p.order ASC';
		if (!$limit) {
			$db->setQuery( $q );
		} else {
			$db->setQuery( $q, $limitstart, $limit );
		}
		$ret = $db->loadObjectList(); 	
		return $ret;
	}
	
	function processUserCPTask($task = '', $data = '', $playlist = ''){
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');			require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;	
		$itemid = helperTools::getItemid('userpanel');	
		$user = helperTools::isLogin();
		if (!is_numeric($data)) {
			if (strlen($data) == 13) {
				$db = &JFactory::getDBO(); 
				$q = "SELECT * FROM #__dv_videos WHERE vname = '" . $data . "'";		
				$db->setQuery( $q );
				$v = $db->loadObject();	
			}
		} elseif (is_numeric($data)) {
			$v =& JTable::getInstance('dv_videos', 'Table');
			$v->load($data);
		}

		switch($task) {
			case 'deleteVideo':
				$createdate =& JFactory::getDate(time());
				$v->logdate = $createdate->toFormat();
				$v->log = 1;
				$text = JText::_('DV_P_CP_VIDEODELETED');
				$type = 'message';			
				if (!helperTools::saveVData($v, 'dv_videos')) {				
				   $text = JText::_('DV_P_CP_VIDEODELETEDFAIL'); $type = 'error';
				} else {			
					$db = &JFactory::getDBO(); 	
					$q = "DELETE FROM #__dv_uchannelsitems WHERE vid = '".$v->id."' AND uid = '".$user->id."'";
					$db->setQuery( $q );
					$db->query();	
					$q = "DELETE FROM #__dv_ugroupsitems WHERE vid = '".$v->id."' AND uid = '".$user->id."'";
					$db->setQuery( $q );
					$db->query();		
					$q = "DELETE FROM #__dv_playlistitems WHERE vid = '".$v->id."'";
					$db->setQuery( $q );
					$db->query();		
					$q = "DELETE FROM #__dv_favorites WHERE vid = '".$v->id."'";
					$db->setQuery( $q );
					$db->query();						
					
					//onplugins video after delete video		
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoDeleted', array(&$user, &$v) );

					if ($init->communitySys == 1) {
						require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
						$tp = new thirdparties;					
						if ($init->js_userpoint == 1) { $tp->givePoint(13);}
						if ($init->js_as_deletevideo == 1) { $tp->stream(13,$v->userid);}
					}				
				}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&Itemid='.$itemid, $text, $type);
				$controller->redirect();				
			break;
			case 'editVideo':		
				$cats = array();
				$categories=helperTools::getCategoriesTool('id,name'); 
				$cats[] = JHTML::_('select.option', '', JText::_( 'DV_F_CATEGORYCHOOSE' ) );
				foreach ($categories as $category) {
					$cats[] = JHTML::_('select.option',  $category->id, JText::_( $category->name ) );
				}	
				$c = null;			
				$c .= '<script type="text/javascript">';
				$c .= ($init->loadjqnoconflict == true) ? "jQuery.noConflict();" : "";
				$c .= 'jQuery(document).ready(function(){ 
				jQuery.validationEngine.closePrompt(".formError",true);
				jQuery("#vUpForm").validationEngine({
				promptPosition: "centerRight",
				success : false,
				failure : function() {}
				});
				});</script>';
				$c .= '<form id="vUpForm" name="vUpForm" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post" enctype="multipart/form-data">	<table class="vformtable">';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_TITLE' ).':</td>';
				$c .= '<td><input class="validate[required] inputbox" type="text" name="title" id="title" size="40" maxlength="250" value="'.$v->title.'" /></td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_DESCRIPTION' ).':</td><td>';
				$c .= '<textarea class="validate[required] inputbox" type="textarea" name="description" id="description" rows="5" cols="41" maxlength="200">'.$v->description.'</textarea></td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_TAGS' ).':</td>';
				$c .= '<td><input class="validate[required,custom[tags]] inputbox" type="text" name="tags" id="tags" size="40" maxlength="250" value="'.$v->tags.'" /><div>'.JText::_('DV_F_DESC_TAGS').'</div></td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_CATEGORY' ).':</td><td>'.helperTools::genericList( $cats, 'category', 'class="validate[required]"', $v->catid).'</td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_LOCATION_REC' ).':</td>';
				$c .= '<td><input class="inputbox" type="text" name="loc_record" id="loc_record" size="40" maxlength="250" value="'.$v->loc_record.'" /></td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_ACCESSTYPE' ).':</td><td>'. helperTools::booleanList( 'accesstype', null, $v->accesstype, 'DV_F_PUBLIC', 'DV_F_PRIVATE' ).'</td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_ALLOW_COMMENTS' ).'?</td><td>'.helperTools::booleanList( 'allow_comments', null, $v->allow_comments ).'</td></tr>';
				$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_ALLOW_RATINGS' ).'?</td>';
				$c .= '<td>'.helperTools::booleanList( 'allow_ratings', null, $v->allow_ratings ).'</td></tr>';
				if($init->allowEmbed == 1) {					
					$c .= '<tr><td class="vfkey">'.JText::_( 'DV_F_ALLOW_EMBEDDING' ).'?</td>';
					$c .= '<td>'.helperTools::booleanList( 'allow_embedding', null, $v->allow_embedding ).'</td></tr>';
				}
				if ( ($v->vid_type == 'u') || 
					 ( ($init->fetchlinkonly == false) && ($init->fetchType == false) && ($v->vid_type == 'g') ) ) { 
					$c .= '<tr>
							<td class="vfkey">'.JText::_( 'DV_F_NEWTHUMBNAIL' ).'? </td>
							<td>
							<div>'.JText::_('DV_F_THUMBALTERDESC').'</div>
							<div style="float:left;width:50px;padding:0 10px 0 0;"><input class="validate[custom[time]] inputbox" type="text" name="tntime" id="tntime" size="5" maxlength="5"/></div><div style="padding:2px 0 0 3px;font-size:0.9em">'.JText::_('DV_F_THUMBALTERINST').'</div></td>
							</tr>';		 
				} 		
				$c .=	'<tr><td class="vfkey">'.JText::_('DV_F_THUMBALTERFORMAT').'</td>							
																						
							<td><div style="float:left;width:200px"><input id="tnsrcfile" type="file" name="tnsrcfile"  size="20"/><br>'.JText::_('DV_F_THUMBALTERBLANK').'</div></td>
							</tr>';								
				
				$c .= '</table>';				
				$c .= '<input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="saveVideo" />
					   <input name="info" id="info" type="hidden" value="'.$data.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="format" type="hidden" id="format" value="raw" />
					   <input name="controller" type="hidden" value="userpanel" />
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form>';
				return $c;
			break;
			case 'saveVideo':
				$tnflag = null;
                $v->title = helperTools::cleantext(JRequest::getVar( 'title', null),false);
                $v->description = helperTools::cleantext(JRequest::getVar( 'description', null),false);
                $v->tags = helperTools::cleantext(JRequest::getVar( 'tags', null),false);
                $catid = JRequest::getVar( 'category', null);
                if (is_numeric($catid)) {$v->catid = $catid;}
                $v->loc_record = helperTools::cleantext(JRequest::getVar( 'loc_record', null),false);
                $v->accesstype = JRequest::getVar( 'accesstype', null);
                $v->allow_comments = JRequest::getVar( 'allow_comments', null);
                $v->allow_ratings = JRequest::getVar( 'allow_ratings', null);
                $v->allow_embedding = JRequest::getVar( 'allow_embedding', null);		
                $time = JRequest::getVar( 'tntime', null);	
                $tnf = JRequest::getVar( 'tnsrcfile', null, 'files', 'array');
				if ($tnf['error'] == 0) {
					$fileExt = strtolower(jFile::getExt ($tnf['name']));
					if (($fileExt == 'png')||($fileExt == 'jpg')||($fileExt == 'gif')) {			
						$ret = $this->newThumbm($v->vid, $tnf, true);
						if ($ret == true) {
							$flag = true;
							$vdo =& JTable::getInstance('dv_videos', 'Table');
							$vdo->load($id);			
							$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos';
							$folders = JFolder::folders($base.DS.'pics'.DS.'small');				
							for ($i=0;$i<count($folders);$i++) {
							$resizedfile = $base.DS.'pics'.DS.'small'.DS.$folders[$i].DS.$vdo->vid.'.jpg';
								if (JFile::exists($resizedfile)){JFile::delete($resizedfile);}
							}				
							$tnflag = true;	
						} else {
							if (isset($ret['msg'])) {
								JError::raiseWarning( 500, $ret['msg']);
							} else {
								JError::raiseWarning( 500, JText::_('DV_F_THUMBCANNOTGENERATE'));					
							}
						}
					} else {$msg = JText::_('DV_F_THUMBWRONGFORMAT'); $msgtype = 'error';JError::raiseWarning( 500, $msg);}	
				}                 
                if ($time) {
					require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
					$ret = viewTools::makeNewThumbNail($v, $time, $init);
					if ($ret['ok']) {
						$tnflag = true;
					} else {
						JError::raiseWarning( 500, JText::_('DV_F_THUMBGENERROR'));
					}
                }
				$v->title = helperTools::cleantext($v->title);
				$v->description = helperTools::cleantext($v->description);
				$v->tags = helperTools::cleantext($v->tags);
				$tags = helperTools::filtersymbol($v->tags, true);
				$strs = explode(',', $tags);
				$str = array();
				for ($i=0;$i<count($strs);$i++) {
					if (!empty($strs[$i])) {
						$str[] = trim($strs[$i]);
					}
				}
				$v->tags = implode(', ', $str);						
				$v->loc_record = helperTools::cleantext($v->loc_record);
				$text = ($tnflag) ? JText::_('DV_F_THUMBGENSUCCESS') : JText::_('DV_P_CP_VIDEOEDITED');
				$type = 'message';
				if (!helperTools::saveVData($v, 'dv_videos')) {				
					   $text = JText::_('DV_P_CP_VIDEOEDITFAIL'); $type = 'error';}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&Itemid='.$itemid, $text, $type);
				$controller->redirect();				
			break;
			case 'addToFavorite':
				$createdate =& JFactory::getDate(time());
				if (!helperTools::checkFieldExist('vid', $data, 'dv_favorites', 'uid', $user->id)) {
					$log='';
					$log->uid = $user->id;
					$log->vid = $data;
					$log->date = $createdate->toFormat();
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_favorites')) {
						$v->totalfavorites = $v->totalfavorites + 1;
						if (helperTools::saveVData($v, 'dv_videos')) {
							$ret = JText::_('DV_P_SUCCESS_ADDFAV');
						}
							
						//onplugins video after video added as favorite	
						$dispatcher =& JDispatcher::getInstance();
						$dispatcher->trigger( 'onAfterVideoAddedToFavorite', array(&$user, &$v) );
								
						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(15);$tp->givePoint(18,$v->userid);}
							$jsas->p = true;$jsas->vid = $v->vname;$jsas->name = helperTools::trimStr($v->title, 6);
							if (($init->js_as_favvideo == 1)&&($v->accesstype)) { $tp->stream(15,$user->id,$jsas);}
						}	
					}
				} else {$ret = JText::_('DV_P_ALREADYFAVADDED');}					
			break;
			case 'addToFavorite2':
				$createdate =& JFactory::getDate(time());
				if (!helperTools::checkFieldExist('vid', $data, 'dv_favorites', 'uid', $user->id)) {
					$log='';
					$log->uid = $user->id;
					$log->vid = $data;
					$log->date = $createdate->toFormat();
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_favorites')) {
						$v->totalfavorites = $v->totalfavorites + 1;
						if (helperTools::saveVData($v, 'dv_videos')) {
							$ret = JText::_('DV_P_SUCCESS_ADDFAV2');
							$type = '';
						}
							
						//onplugins video after video added as favorite	
						$dispatcher =& JDispatcher::getInstance();
						$dispatcher->trigger( 'onAfterVideoAddedToFavorite', array(&$user, &$v) );
							
						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(15);$tp->givePoint(18,$v->userid);}
							$jsas->p = true;$jsas->vid = $v->vname;$jsas->name = helperTools::trimStr($v->title, 6);
							if (($init->js_as_favvideo == 1)&&($v->accesstype)) { $tp->stream(15,$user->id,$jsas);}
						}	
					}
				} else {$ret = JText::_('DV_P_ALREADYFAVADDED2'); $type="error";}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showSubChannel&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'addToFavorite3':
				$createdate =& JFactory::getDate(time());
				if (!helperTools::checkFieldExist('vid', $data, 'dv_favorites', 'uid', $user->id)) {
					$log='';
					$log->uid = $user->id;
					$log->vid = $data;
					$log->date = $createdate->toFormat();
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_favorites')) {
						$v->totalfavorites = $v->totalfavorites + 1;
						if (helperTools::saveVData($v, 'dv_videos')) {
							$ret = JText::_('DV_P_SUCCESS_ADDFAV2');
							$type = '';
						}
					}
							
					//onplugins video after video added as favorite	
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoAddedToFavorite', array(&$user, &$v) );
							
					if ($init->communitySys == 1) {
						require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
						$tp = new thirdparties;					
						if ($init->js_userpoint == 1) { $tp->givePoint(15);$tp->givePoint(18,$v->userid);}
						$jsas->p = true;$jsas->vid = $v->vname;$jsas->name = helperTools::trimStr($v->title, 6);
						if (($init->js_as_favvideo == 1)&&($v->accesstype)) { $tp->stream(15,$user->id,$jsas);}
					}	
				} else {$ret = JText::_('DV_P_ALREADYFAVADDED2'); $type="error";}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showJoinedGroup&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'choosePlaylist':			
                $layout = JRequest::getVar( 'layout', null);			
				$pls = $this->getUserPlaylist($user->id);	
				$parr = array();
				for($i=0;$i<count($pls);$i++) {
					$parr[] = JHTML::_('select.option', $pls[$i]->id, $pls[$i]->playlist );
				}
				$c = '<table width="350px" align="center" border="0"><tr><td align="center"><form id="vPLForm" name="vPLForm" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post">';
				$c .= '<div>'.JText::_('DV_P_CP_PLFORM').'</div><div>"'.$v->title.'"</div>';
				if (count($pls) == 0) {
					$c .= JText::_('DV_P_CP_TO') . ' <input class="inputbox" type="text" name="createPlaylist" id="createPlaylist" size="20" maxlength="150" />';
				} else {
					$c .= JText::_('DV_P_CP_TO') . ' ' .helperTools::genericList( $parr, 'addToPlaylist', null, null );
				}
				$c .= '<input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="addToPlaylist" />
					   <input name="info" id="info" type="hidden" value="'.$v->id.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="layout" type="hidden" id="layout" value="'.$layout.'" />					   
					   <input name="controller" type="hidden" value="userpanel" /><p/choo>
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></td></tr></table>';
				
				return $c;
			break;
			case 'addToPlaylist':
				$cpl = JRequest::getVar( 'createPlaylist', null);
                $pL = JRequest::getVar( 'addToPlaylist', null);	
                $layout = JRequest::getVar( 'layout', null);
                             
                if ($cpl) {
                	$db = &JFactory::getDBO();
                	$cpl = $db->getEscaped(helperTools::cleantext($cpl));
					$createdate =& JFactory::getDate(time());
					$log='';
					$log->uid = $user->id;
					$log->playlist = $cpl;
					$log->date = $createdate->toFormat();
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_playlist')) {
						$q = "SELECT * FROM #__dv_playlist WHERE uid = '".$user->id."'";
						$db->setQuery( $q );
						$result = $db->loadObject();
						$pL = $result->id;
					}	                
                }
				if (($pL)||(!$pL==0)||(!$pL=='')) {
					if (!helperTools::checkFieldExist('vid', $v->id, 'dv_playlistitems', 'uid', $user->id, 'playlist', $pL)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->vid = $v->id;
						$log->playlist = $pL;
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');$type = 'error';
						if (helperTools::playlistPlayable($v->id)) {
							if (helperTools::saveVData($log, 'dv_playlistitems')) {
								$v->totalplaylist = $v->totalplaylist + 1;
								if (helperTools::saveVData($v, 'dv_videos')) {
									$ret = JText::_('DV_P_SUCCESS_ADDPLAYLIST2');
									$type = '';
									
							//onplugins video after add video to playlist	
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterVideoAddedToPlaylist', array(&$user, &$v, &$log) );
								
									if ($init->communitySys == 1) {
										require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
										$tp = new thirdparties;					
										if ($init->js_userpoint == 1) { $tp->givePoint(45);$tp->givePoint(47,$v->userid);}
										$jsas->p = true;$jsas->vid = $v->vname;$jsas->name = helperTools::trimStr($v->title, 6);
										if (($init->js_as_playlist_addvideo == 1)&&($v->accesstype)) { $tp->stream(45,$user->id,$jsas);}
									}									
								}
							}
						} else { $ret = JText::_('DV_P_VLINKPLAYLIST3');$type = 'error'; }
					} else {$ret = JText::_('DV_P_VEXISTPLAYLIST2');$type = 'error';}
				} else {$ret = JText::_('DV_P_EMPTYPLAYLIST2');$type = 'error';}	
				$layout = ($layout) ? '&layout='.$layout : '';
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel'.$layout.'&Itemid='.$itemid, $ret, $type);
				$controller->redirect();			
			break;	
			case 'deleteFav':
				$db = &JFactory::getDBO();
				$q = "DELETE FROM #__dv_favorites WHERE vid = '".$v->id."' AND uid = '".$user->id."'";
				$db->setQuery( $q );
				if (!$db->query()) {
				   	$text = JText::_('DV_P_CP_VIDEODELETEDFAVFAIL'); $type = 'error';
				} else {
					$text = JText::_('DV_P_CP_VIDEODELETEDFAV'); $type = '';
					
					//onplugins video after video remove from favorite	
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoRemovedFromFavorite', array(&$user, &$v) );
						
					if (($init->communitySys == 1)&&($init->js_userpoint == 1)) {
						require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
						$tp = new thirdparties;					
						$tp->givePoint(14);$tp->givePoint(17,$v->userid);
					}						
				}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&Itemid='.$itemid, $text, $type);
				$controller->redirect();				
			break;
			case 'createplaylist':			
				$data = JRequest::getVar( 'createPlaylist', $data);				
				if (($data) && ($data != JText::_('DV_P_CP_CPLBTN'))){
					$db = &JFactory::getDBO();
					$data = $db->getEscaped(helperTools::cleantext($data));
					if (!helperTools::checkFieldExist('playlist', $data, 'dv_playlist', 'uid', $user->id)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->playlist = $data;
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');
						if (helperTools::saveVData($log, 'dv_playlist')) {
							$ret = JText::_('DV_P_SUCCESS_CREATPLAYLIST2'); $type = '';
						}
					} else {$ret = JText::_('DV_P_EXISTPLAYLIST2'); $type = 'error';}
				} else {$ret = JText::_('DV_P_EMPTYPLAYLIST3'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'delplaylist':			
				$dpl = JRequest::getVar( 'playlistNo', $data);
				if ($dpl) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_playlist WHERE id = '".$data."' AND uid = '".$user->id."'";
					$db->setQuery( $q );					
					if ($db->query()) {
					   	$q = "DELETE FROM #__dv_playlistitems WHERE playlist = '".$data."'";
					   	$db->setQuery( $q );
						if ($db->query()) {
							$ret = JText::_('DV_P_CP_PLAYLISTDELETED'); $type = '';
						} else {$ret = JText::_('DV_P_CP_PLAYLISTDELETEDFAIL'); $type = 'error';}					   	
					} else {$ret = JText::_('DV_P_CP_PLAYLISTDELETEDFAIL'); $type = 'error';}
				} else {$ret = JText::_('DV_P_EMPTYPLAYLIST2'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'delvideofrompl':
				$plno = JRequest::getVar( 's', '');
				if (($plno) && ($data)) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_playlistitems WHERE vid = '".$data."' AND playlist = '".$plno."'";
					$db->setQuery( $q );										
					if ($db->query()) {
						$ret = JText::_('DV_P_CP_VPLAYLISTDELETED'); $type = '';
						
						//onplugins playlist after remove video to playlist	
						$dispatcher =& JDispatcher::getInstance();
						$dispatcher->trigger( 'onAfterVideoRemovedFromPlaylist', array(&$user, &$v, &$plno) );
					
						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(46);$tp->givePoint(48,$v->userid);}
							$jsas->p = true;$jsas->vid = $v->vname;$jsas->name = helperTools::trimStr($v->title, 6);
							if (($init->js_as_playlist_removevideo == 1)&&($v->accesstype)) { $tp->stream(46,$user->id,$jsas);}
						}						
					} else {$ret = JText::_('DV_P_CP_VPLAYLISTDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_EMPTYPLAYLIST5'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&s='.$plno.'&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'MoveVPlaylist':
			    $layout = JRequest::getVar( 'layout', null);
				$pls = $this->getUserPlaylist($user->id);	
				$parr = array();
				for($i=0;$i<count($pls);$i++) {
					if ($pls[$i]->id != $playlist) { 
						$parr[] = JHTML::_('select.option', $pls[$i]->id, $pls[$i]->playlist );
					} else {
						$srcName = $pls[$i]->playlist;
					}
				}
				$c = '<table width="350px" align="center" border="0"><tr><td align="center"><form id="vPLForm" name="vPLForm" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post">';
				$c .= '<div>'.JText::_('DV_P_CP_PLFORM2').'</div><div>"'.$v->title.'"</div>';
				$c .= '<div>'.JText::_('DV_P_CP_FROM').'</div><div>"'.$srcName.'"</div>';
				if (count($pls) == 1) {
					$c .= JText::_('DV_P_CP_TO') . ' <input class="inputbox" type="text" name="createPlaylist" id="createPlaylist" size="20" maxlength="150" />';
				} else {
					$c .= JText::_('DV_P_CP_TO') . ' ' .helperTools::genericList( $parr, 'moveToPlaylist', null, null );
				}
				$c .= '<input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="moveToPlaylist" />
					   <input name="info" id="info" type="hidden" value="'.$v->id.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="p" type="hidden" id="p" value="'.$playlist.'" />
					   <input name="layout" type="hidden" id="layout" value="'.$layout.'" />
					   <input name="controller" type="hidden" value="userpanel" />
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></td></tr></table>';
				return $c;				
			break;
			case 'moveToPlaylist';
				$cpl = JRequest::getVar( 'createPlaylist', null);				
				$srcpl = JRequest::getVar( 'p', '');		
				$distpl = JRequest::getVar( 'moveToPlaylist', '');		
				$db = &JFactory::getDBO();
                if ($cpl) {     	
                	$cpl = $db->getEscaped(helperTools::cleantext($cpl));
					$createdate =& JFactory::getDate(time());
					$log='';
					$log->uid = $user->id;
					$log->playlist = $cpl;
					$log->date = $createdate->toFormat();
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_playlist')) {
						$q = "SELECT * FROM #__dv_playlist WHERE playlist = '".$cpl."' AND uid = '".$user->id."'";
						$db->setQuery( $q );
						$result = $db->loadObject();
						$distpl = $result->id;
					}	                
                }
                if ($distpl) {
				$q = 'SELECT * FROM #__dv_playlistitems WHERE playlist = "'.$srcpl.'" AND vid = "'.$v->id.'"';
					$db->setQuery( $q );
					$p = $db->loadObject(); 	
					$p->playlist = $distpl;
					if (helperTools::checkDupeEntry($distpl, 'playlist', 'dv_playlistitems', $v->id, 'vid')) {
						if (!helperTools::saveVData($p, 'dv_playlistitems')) {				
							   $text = JText::_('DV_P_CP_VPLMOVEFAIL'); $type = 'error';
						} else { $text = JText::_('DV_P_CP_VPLMOVE'); $type = '';}
					} else { $text = JText::_('DV_P_CP_VPLMOVEFAILDUPE'); $type = 'error';}
				} else { $text = JText::_('DV_P_CP_VPLMOVEFAIL'); $type = 'error'; }
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&s='.$srcpl.'&Itemid='.$itemid, $text, $type);
				$controller->redirect();							
			break;
			case 'orderup':
				$session =& JFactory::getSession();
				$p = $session->get('p', '', 'jvideodirect');					
				$this->orderupdown($p, $data ,-1);
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&s='.$p.'&Itemid='.$itemid);
				$controller->redirect();
			break;
			case 'orderdown':
				$session =& JFactory::getSession();
				$p = $session->get('p', 1, 'jvideodirect');						
				$this->orderupdown($p, $data , 1);
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&s='.$p.'&Itemid='.$itemid);
				$controller->redirect();
			break;
			case 'saveorder':
				$session =& JFactory::getSession();
				$p = $session->get('p', 1, 'jvideodirect');	
				$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
				$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );	
				JArrayHelper::toInteger($cid);
				JArrayHelper::toInteger($order);
				if ($this->saveOrder($cid, $order)) {
					$this->reorder($p);
					$ret = JText::_('DV_P_CP_ORDERSAVE'); $type = '';
				} else { $ret = JText::_('DV_P_CP_ORDERSAVEFAIL'); $type = 'error';}
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=myplaylists&s='.$p,'&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;		
			case 'delsubchannel':
				if ($data) {
					$row =& JTable::getInstance('dv_channels', 'Table');
					$row->load($data);				
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_channels WHERE id = '".$data."'";
					$db->setQuery( $q );										
					if ($db->query()) {
						$update =& JTable::getInstance('dv_uchannels', 'Table');
						$update->load($row->cid);
						$update->subscribers = $update->subscribers - 1;
						if (helperTools::saveVData($update, 'dv_uchannels')) {
							$ret = JText::_('DV_P_CP_CHANNELDELETED'); $type = '';
							
							//onplugins channel after unsubscribe channel
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterChannelUnsubscribed', array(&$user, &$update) );
						
							if ($init->communitySys == 1) {		
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(23);$tp->givePoint(27,$update->uid);}
								$jsas->p = true;$jsas->vid = $update->id;$jsas->name = helperTools::trimStr($update->channel, 6);
								if (($init->js_as_unsubchannel == 1)&&($update->access_type)) { $tp->stream(23,$user->id,$jsas);}				
							}							
						} else {$ret = JText::_('DV_P_CP_CHANNELDELETEDFAIL'); $type = 'error';}								
					} else {$ret = JText::_('DV_P_CP_CHANNELDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_EMPTYCHANNELNO'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=subchannels&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;
			case 'sortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('oi', $filter_order, 'jvideodirect');					
				$session->set('od', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=subchannels&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'showMyChannel':
			case 'showSubChannel':
				$session =& JFactory::getSession();		
				switch ($task) {
					case 'showMyChannel':
						$session->set('mchid', $data, 'jvideodirect');	
						$layout = 8;
					break;
					case 'showSubChannel':
						$session->set('schid', $data, 'jvideodirect');	
						$layout = 6;
					break;
				}			
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout='.$layout.'&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'createChannel':			
				$data = JRequest::getVar( 'createChannel', $data);				
				if (($data) && ($data != JText::_('DV_P_CP_CCHBTN'))) {
					$db = &JFactory::getDBO();
					$data = $db->getEscaped(helperTools::cleantext($data));
					if (!helperTools::checkFieldExist('channel', $data, 'dv_uchannels', 'uid', $user->id)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->channel = $data;
						$log->access_type = '1';
						$log->status = 'inactive';
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');
						if (helperTools::saveVData($log, 'dv_uchannels')) {
							$ret = JText::_('DV_P_SUCCESS_CREATCHANNEL'); $type = '';
						}
					} else {$ret = JText::_('DV_P_EXISTCHANNEL'); $type = 'error';}
				} else {$ret = JText::_('DV_P_EMPTYCHANNEL'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mychannels&Itemid='.$itemid, $ret, $type);
				$controller->redirect();		
			break;			
			case 'editChannel':
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				$ret = '';
				$row =& JTable::getInstance('dv_uchannels', 'Table');
				$row->load($data);
				if ($row->uid == $user->id) {
					if (!$row->image == 0) {
						$image = '<img style="padding:5px 0 0 5px" src="'.JURI::base().'jMediaDirect/videos/pics/channels/'.$user->id.'/'.$row->image.'.png" height="60px"/>';
					} else {$image = '<font color="#ccc">'.JText::_('DV_P_CP_NOIMAGE').'</font>';}
					$script = '<script type="text/javascript">function pwd(id) {if (id == "1") { document.getElementById("password").style.display = "none";} else { document.getElementById("password").style.display = "block";}}
					function clearText (el) { if (el.defaultValue == el.value) el.value = "";el.style.color="#888";}
					function restoreText (el) { if (el.value == "") {el.value = el.defaultValue;el.style.color="#888";}}</script>';		
					$script .= '<script type="text/javascript">function ajaxFunction(uniquename) {
								var xmlHttp; try { xmlHttp=new XMLHttpRequest(); }
								catch (e) { try { xmlHttp=new ActiveXObject("Msxml2.XMLHTTP"); }
								catch (e) { try { xmlHttp=new ActiveXObject("Microsoft.XMLHTTP"); }
								catch (e) { alert("Your browser does not support AJAX!"); return false; } } }
								var url="'.JURI::BASE().'index.php?option=com_jvideodirect&task=checkPermaName&'.JUtility::getToken().'=1&format=raw&t=channel&p='.$row->id.'&c=";
								url=url+uniquename;
								xmlHttp.onreadystatechange=function() {
								if(xmlHttp.readyState==4) { var r=xmlHttp.responseText;
								if (r != "") document.getElementById("ajaxResult").innerHTML=r; } }
								xmlHttp.open("GET",url,true);
								xmlHttp.send(null);}</script>';					
					
					if ($user->username == $row->channel) {
						$title = $row->channel;
					} else { $title = '<input id="chname" type="text" name="chname" value="'.$row->channel.'" size="28">';}
					$desc = '<input id="chdesc" type="text" name="chdesc" value="'.$row->description.'" size="40">';	
					$tags = '<input id="chtags" type="text" name="chtags" value="'.$row->tags.'" size="40">';					
					$accesstypeO = array(0 => JHTML::_('select.option', 1, JText::_('DV_F_PUBLIC') ),JHTML::_('select.option', 0, JText::_('DV_F_PRIVATE') ));															
					$accesstype = helperTools::genericList($accesstypeO, 'accesstype', ' onclick="pwd(this.value);" ', $row->access_type);
					if ($row->pwd) {$row->pwd = 'jVideoDirect';}
					$pwdinput = '<input id="cpwd" type="password" name="cpwd" value="'.$row->pwd.'" onfocus="clearText(this);" onblur="restoreText(this);" size="20" style="color:#888"/>';
					$display = ($row->access_type) ? 'none' : 'block';
					if ($row->status == 'inactive') {$statusCode = '0';} else {$statusCode = ($row->status == 'active') ? '1':'2'; }
					$statusO = array();	
					if ($statusCode == '2') {$statusO[] = JHTML::_('select.option', 2, JText::_('DV_P_CP_SUSPEND'));} else {
					$statusO[] = JHTML::_('select.option', 1, JText::_('DV_P_CP_ACTIVE'));
					$statusO[] = JHTML::_('select.option', 0, JText::_('DV_P_CP_INACTIVE'));
					}
					$status = helperTools::genericList($statusO, 'status', '', $statusCode);	
					$atitle = '<input type="text" id="uname" name="uname" size="20" value="'.$row->unique.'" class="inputbox" maxlength="40" onblur="ajaxFunction(this.value);"/>';
				} else {$ret = '<h4 style="color:red;text-align:center">'.JText::_('DV_P_CP_CHANNELNOPERMISSION').'</h4>';}

				if (!$ret) {
					$ret = $script.'<div style="display:block;width:300px;margin:0 auto;">
					<form id="editchannel" name="editchannel" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post" enctype="multipart/form-data">';
					$ret .= '<div>'.$image.'</div>						
					   <div style="padding-top:10px">'.JText::_('DV_P_CP_CHANNELIMAGE').':</div>
					   <div><input id="chphoto" type="file" name="chphoto"  size="28"/></div>
					   <div style="font-size:0.9em;font-style:italic;">'.JText::_('DV_P_CP_SUPPORTFORMAT').': png , jpg , gif</div>
					   <div style="padding-top:10px">'.JText::_('DV_P_CP_UNIQUENAME').': </div>
					   <div style="height:25px">
					   		<div style="float:left;color:#1b44f3;font-size:1.2em;font-weight:bold;">'.$atitle.'</div>
					   		<div id="ajaxResult" style="padding-left:5px"></div>
					   </div>	  
					   <div style="padding-top:10px">'.JText::_('DV_P_CP_CHANNELNAME').': '.$title.'</div>	
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_CHANNELDESC').': '.$desc.'</div>	
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_KEYWORDS').': '.$tags.'</div><div style="font-size:0.9em;float:right"><i>('.JText::_('DV_P_SEPARATOR').')</i></div>
					   <div style="padding-top:15px">'.JText::_('DV_F_ACCESSTYPE').': '.$accesstype.'</div>
					   <div id="password" style="display:'.$display.';">
					   <div style="padding-top:15px;">'.JText::_('DV_P_CP_PASSWORD').': '.$pwdinput.'</div>
					   <div style="padding-top:1px;font-size:0.9em;line-height:13px;">'.JText::_('DV_P_CP_CPWDCOMMENT').'</div></div>
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_STATUS').': '.$status.'</div>';
						if ($statusCode == '2') { 
						$ret .= '<div style="font-size:0.9em;color:red;line-height:13px">'.JText::_('DV_P_CP_CSUSCOMMENT').'</div>';	
						}	
						$ret .='
					   <input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="saveChannel" />
					   <input name="info" id="info" type="hidden" value="'.$data.'" />
					   <input name="task" type="hidden" id="task" value="job" />				   
					   <input name="p" type="hidden" id="p" value="'.$playlist.'" />
					   <input name="layout" type="hidden" id="layout" value="7" />
					   <input name="controller" type="hidden" value="userpanel" /><br/>
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></div>';
					}					
				return $ret;
			break;
			
			case 'saveChannel':
				$messageflag = 0;
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'channels';
				$data = JRequest::getVar('info',$data);
				$unique = helperTools::cleantext(JRequest::getVar('uname',''),false);
				$title = helperTools::cleantext(JRequest::getVar('chname',''),false);
				$desc = helperTools::cleantext(JRequest::getVar('chdesc',''),false);
				$tags = helperTools::tagStd(JRequest::getVar('chtags',''),false);				
				$srcphoto = JRequest::getVar( 'chphoto', null, 'files', 'array');

				if ($srcphoto['error'] == 0) {
					$fileExt = strtolower(jFile::getExt ($srcphoto['name']));
					if (($fileExt == 'png')||($fileExt == 'jpg')||($fileExt == 'gif')) {
						$name = helperTools::processChImage($srcphoto, $user->id, 1);
						if ($name[1] == true) {
							if (JFile::exists($base.DS.$user->id.DS.$name[0].'.png')) {
							$imageok = true; } else {$imageok = false;} 	
						} else {$ret = JText::_('DV_P_CP_UPLOADERROR'); $type = 'error';}
					} else {$ret = JText::_('DV_P_CP_WRONGFORMAT'); $type = 'error';}
				}

				$row =& JTable::getInstance('dv_uchannels', 'Table');	
				$row->load($data);				
				$old = $base.DS.$user->id.DS.$row->image.'.png';
				if ($unique) {
					if ($this->checkUniqueName( $unique, $data, 'channel', true)) {
						$db = &JFactory::getDBO();
						$row->unique = $db->getEscaped(helperTools::cleantext($unique));
					} else {$message = JText::_('DV_P_CP_TAKENBEFORESAVE'); JError::raiseWarning( 500, $message);}
				}
				if ($title) {
					$db = &JFactory::getDBO();
					$row->channel = $db->getEscaped(helperTools::cleantext($title));
				}
				if ($desc) {
					$db = &JFactory::getDBO();
					$row->description = $db->getEscaped(helperTools::cleantext($desc));
				}
				$row->tags = $tags;												
				if (($srcphoto['error'] == null) && ($imageok)) {
					$row->image = $name[0];
				}
				$pwd = JRequest::getVar('cpwd','');	
				if ($pwd){if ($pwd != 'jVideoDirect'){$row->pwd = helperTools::cryptpwd($pwd);}}
				$status = JRequest::getVar('status','');					
				if ($status == '0') {$row->status = 'inactive';} else {$row->status = ($status == '1') ? 'active':'suspended'; }	
								
				$row->access_type = JRequest::getVar('accesstype','');
				if (($pwd == null) && ($status == 1) && ($row->access_type == 0)) {
					$messageflag = 1;
					$row->status = 'inactive';				
				}
								
				//onplugins channel after create and activate channel	
				if (($row->status == 'active') && (!$row->acount)) {
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterChannelPublished', array(&$user, &$row) );
				}

				if (($row->status == 'active') && (!$row->acount) && ($init->communitySys == 1)) {		
					require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
					$tp = new thirdparties;					
					if ($init->js_userpoint == 1) { $tp->givePoint(21);}
					$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->channel, 6);
					if (($init->js_as_creatchannel == 1)&&($row->access_type)) { $tp->stream(21,$row->uid,$jsas);}
					$row->acount = $row->acount + 1;					
				}
				if ($row->store()) {
					if ($srcphoto['error'] == 0) {
						if (JFile::exists($old)) {JFile::delete($old);}
					}
					$ret = ($messageflag == 1) ? JText::_('DV_P_CP_CHANNELUPDATEDBUT') : JText::_('DV_P_CP_CHANNELUPDATED'); $type='';
				} else {$ret = JText::_('DV_P_CP_CHANNELUPDATEFAIL'); $type='error';}

				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mychannels&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'removeChannel':
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				if ($data) {
					$row =& JTable::getInstance('dv_uchannels', 'Table');	
					$row->load($data);
					$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'channels';
					$old = $base.DS.$user->id.DS.$row->image.'.png';
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_uchannels WHERE id = '".$data."'";
					$db->setQuery( $q );										
					if ($db->query()) {
						if (JFile::exists($old)) {JFile::delete($old);}
						$q = "DELETE FROM #__dv_uchannelsitems WHERE cid = '".$data."'";
						$db->setQuery( $q );
						if ($db->query()) {
							$q = "DELETE FROM #__dv_channels WHERE cid = '".$data."'";
							$db->setQuery( $q );
							if ($db->query()) {
								$ret = JText::_('DV_P_CP_CHANNELDELETED1'); $type = '';
								
								//onplugins channel after delete channel	
								$dispatcher =& JDispatcher::getInstance();
								$dispatcher->trigger( 'onAfterChannelDeleted', array(&$user, &$row) );

								if (($init->communitySys == 1)&&($row->acount)) {
									require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
									$tp = new thirdparties;					
									if ($init->js_userpoint == 1) { $tp->givePoint(28);}
								}																		
							} else {$ret = JText::_('DV_P_CP_CHANNELDELETEDFAIL1'); $type = 'error';}
						} else {$ret = JText::_('DV_P_CP_CHANNELDELETEDFAIL1'); $type = 'error';}	
					} else {$ret = JText::_('DV_P_CP_CHANNELDELETEDFAIL1'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_EMPTYCHANNELNO'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mychannels&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;
			case 'chooseChannel':		
				$pls = $this->getUserMyChannel($user->id);	
				$parr = array();
				for($i=0;$i<count($pls);$i++) {
					$parr[] = JHTML::_('select.option', $pls[$i]->id, $pls[$i]->channel );
				}
				$c = '<table width="350px" align="center" border="0"><tr><td align="center"><form id="vChForm" name="vChForm" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post">';
				$c .= '<div>'.JText::_('DV_P_CP_PLFORM').'</div><div>"'.$v->title.'"</div>';
				if (count($pls) == 0) {
					$c .= JText::_('DV_P_CP_TOCHANNEL') . ' <input class="inputbox" type="text" name="createChannel" id="createChannel" size="20" maxlength="150" />';
				} else {
					$c .= JText::_('DV_P_CP_TOCHANNEL') . ' ' .helperTools::genericList( $parr, 'addToChannel', null, null );
				}
				$c .= '<input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="addToChannel" />
					   <input name="info" id="info" type="hidden" value="'.$v->id.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="layout" type="hidden" id="layout" value="1" />					   
					   <input name="controller" type="hidden" value="userpanel" /><p/>
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></td></tr></table>';
				return $c;
			break;
			case 'addToChannel':
				$cpl = JRequest::getVar( 'createChannel', null);
                $pL = JRequest::getVar( 'addToChannel', null);	
                $layout = JRequest::getVar( 'layout', null);                         
                if ($cpl) {
                	$db = &JFactory::getDBO();
                	$cpl = $db->getEscaped(helperTools::cleantext($cpl));
					$createdate =& JFactory::getDate(time());
					$log='';
					$log->uid = $user->id;
					$log->channel = $cpl;
					$log->date = $createdate->toFormat();
					$log->status = 'inactive';
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_uchannels')) {
						$q = "SELECT * FROM #__dv_uchannels WHERE uid = '".$user->id."'";
						$db->setQuery( $q );
						$result = $db->loadObject();
						$pL = $result->id;
					}	                
                }
				if (($pL)||(!$pL==0)||(!$pL=='')) {
					if (!helperTools::checkFieldExist('vid', $v->id, 'dv_uchannelsitems', 'uid', $user->id, 'cid', $pL)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->vid = $v->id;
						$log->cid = $pL;
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');$type = 'error';
						if (helperTools::saveVData($log, 'dv_uchannelsitems')) {
							$ret = JText::_('DV_P_SUCCESS_ADDCHANNEL');
							$type = '';
							
							//onplugins channel after add video to channel	
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterVideoAddedToChannel', array(&$user,&$v, &$pL) );

							if ($init->communitySys == 1) {	
								$row =& JTable::getInstance('dv_uchannels', 'Table');
								$row->load($pL);							
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(25);}
								$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->channel, 6);
								if (($init->js_as_addvchannel == 1)&&($row->access_type)&&($row->status == 'active')) { $tp->stream(25,$user->id,$jsas);}				
							}								
						}
					} else {$ret = JText::_('DV_P_VEXISTCHANNEL');$type = 'error';}
				} else {$ret = JText::_('DV_P_VEMPTYCHANNEL');$type = 'error';}	
				$layout = ($layout) ? '&layout='.$layout : '';
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel'.$layout.'&Itemid='.$itemid, $ret, $type);
				$controller->redirect();			
			break;	
			case 'chSortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('coi', $filter_order, 'jvideodirect');					
				$session->set('cod', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mychannels&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'removeFromCh':
				if ($data) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_uchannelsitems WHERE id = '".$data."' AND uid = '".$user->id."'";
					$db->setQuery( $q );			
					
					//onplugins video after remove video from channel						
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoRemovedFromChannel', array(&$user, &$data) );					
					
					if ($db->query()) {
						$ret = JText::_('DV_P_CP_VCHANNELDELETED'); $type = '';							
						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(29);}
						}							
					} else {$ret = JText::_('DV_P_CP_VCHANNELDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_CP_VEMPTYCHANNEL'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyChannel&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;
			case 'addVideoToChannel':
				if ($data) {
					$row =& JTable::getInstance('dv_uchannels', 'Table');
					$row->load($data);
					$vlist = helperTools::getVideoListDetails($row->uid, 'dateadded', 'DESC');	
					$vdoList = helperTools::getVideoList($vlist, '500px', 5, $data);
					$channel = '<script type="text/javascript">';
					$channel .= ($init->loadjqnoconflict == true) ? "jQuery.noConflict();" : "";
					$channel .= 'jQuery(document).ready(function(){
						jQuery("#jobuserUPAC").submit(function(){
						jQuery.ajax({ 
							data: jQuery(this).serialize(),
							type: jQuery(this).attr("post"), 
							url: jQuery(this).attr("action"),
							success: function(response) { 
								jQuery("#ajaxResult").html(response); 
							}});
						return false;});			
						});';					
					$channel .= '</script>';
					$channel .= '<div style="font-size: 1.5em; height:28px; padding:8px 25px 0 0;">'.JText::_('DV_P_CH_ADDTOCHANNEL').' <font color="#222dbe"><b>'.$row->channel.'</b></font></div>
					<div id="ajaxResult"></div>
					<div>		
						<form id="jobuserUPAC" name="jobuserUPAC" method="post" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'">
							<div class="vspacer5">'.$vdoList.'</div>			
				
						<input type="hidden" name="'.JUtility::getToken().'" value="1" />
						<input name="job3" id="job3" type="hidden" value="processVChAdd" />
						<input name="info3" id="info3" type="hidden" value="" />
						<input name="p" id="p" type="hidden" value="" />
						<input name="format" type="hidden" id="format" value="raw" />
						<input name="task" type="hidden" id="task" value="job" />
						<input name="controller" type="hidden" value="userpanel" />		
						</form>
					</div></div>';		
				}
				echo $channel;			
			break;			
			case 'processVChAdd':
				$cid = $playlist;
				if (($cid)||(!$cid==0)||(!$cid=='')) { 
					if (!helperTools::checkFieldExist('vid', $v->id, 'dv_uchannelsitems', 'uid', $user->id, 'cid', $cid)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->vid = $v->id;
						$log->cid = $cid;
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');$type = 'error';
						if (helperTools::saveVData($log, 'dv_uchannelsitems')) {
							$ret = JText::_('DV_P_SUCCESS_ADDCHANNEL1');

							//onplugins channel after add video to channel	
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterVideoAddedToChannel', array(&$user,&$v, &$cid) );
							
							if ($init->communitySys == 1) {	
								$row =& JTable::getInstance('dv_uchannels', 'Table');
								$row->load($cid);							
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(25);}
								$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->channel, 6);
								if (($init->js_as_addvchannel == 1)&&($row->access_type)&&($row->status == 'active')) { $tp->stream(25,$user->id,$jsas);}				
							}								
						}
					} else {$ret = JText::_('DV_P_VEXISTCHANNEL1');}
				} else {$ret = JText::_('DV_P_VEMPTYCHANNEL1');}		
				echo $ret;
			break;
			case 'createGroup':			
				$data = JRequest::getVar( 'createGroup', $data);				
				if (($data) && ($data != JText::_('DV_P_CP_CGBTN'))) {
					$db = &JFactory::getDBO();
					$data = $db->getEscaped(helperTools::cleantext($data));
					if (!helperTools::checkFieldExist('group', $data, 'dv_ugroups', 'uid', $user->id)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->group = $data;
						$log->date = $createdate->toFormat();
						$log->status = 'inactive';
						$ret = JText::_('DV_P_STOREERROR');
						if (helperTools::saveVData($log, 'dv_ugroups')) {
							$ret = JText::_('DV_P_SUCCESS_CREATGROUP'); $type = '';
						}
					} else {$ret = JText::_('DV_P_EXISTGROUP'); $type = 'error';}
				} else {$ret = JText::_('DV_P_EMPTYGROUP'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mygroups&Itemid='.$itemid, $ret, $type);
				$controller->redirect();		
			break;
			case 'gmySortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('ggoi', $filter_order, 'jvideodirect');					
				$session->set('ggod', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mygroups&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'gSortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('goi', $filter_order, 'jvideodirect');					
				$session->set('god', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=joinedgroups&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'mmSortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('moi', $filter_order, 'jvideodirect');					
				$session->set('mod', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyGroupMembers&Itemid='.$itemid);
				$controller->redirect();	
			break;
			case 'mjSortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('moi', $filter_order, 'jvideodirect');					
				$session->set('mod', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showJoinGroupMembers&Itemid='.$itemid);
				$controller->redirect();	
			break;			
			case 'mcSortOrder':
				$session =& JFactory::getSession();   		
				$filter_order = JRequest::getVar('filter_order', 'DESC');
				$filter_order_Dir = JRequest::getVar('filter_order_Dir', 'DESC');
				$filter_order = ($filter_order) ? $filter_order : 'date';
				$filter_order_Dir = ($filter_order_Dir == 'DESC') ? 'ASC' : 'DESC';
				$session->set('mcoi', $filter_order, 'jvideodirect');					
				$session->set('mcod', $filter_order_Dir, 'jvideodirect');	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyChannelMembers&Itemid='.$itemid);
				$controller->redirect();	
			break;			
			case 'removeGroup':
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				if ($data) {
					$row =& JTable::getInstance('dv_ugroups', 'Table');	
					$row->load($data);
					$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'groups';
					$old = $base.DS.$user->id.DS.$row->image.'.png';
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_ugroups WHERE id = '".$data."'";
					$db->setQuery( $q );										
					if ($db->query()) {
						if (JFile::exists($old)) {JFile::delete($old);}
						$q = "DELETE FROM #__dv_ugroupsitems WHERE gid = '".$data."'";
						$db->setQuery( $q );
						if ($db->query()) {
							$q = "DELETE FROM #__dv_groups WHERE gid = '".$data."'";
							$db->setQuery( $q );
							if ($db->query()) {
								$ret = JText::_('DV_P_CP_GROUPDELETED1'); $type = '';
								
								//onplugins group after delete group	
								$dispatcher =& JDispatcher::getInstance();
								$dispatcher->trigger( 'onAfterGroupDeleted', array(&$user,&$row) );
							
								if (($init->communitySys == 1)&&($row->acount)) {
									require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
									$tp = new thirdparties;					
									if ($init->js_userpoint == 1) { $tp->givePoint(38);}
								}									
							} else {$ret = JText::_('DV_P_CP_GROUPDELETEDFAIL1'); $type = 'error';}
						} else {$ret = JText::_('DV_P_CP_GROUPDELETEDFAIL1'); $type = 'error';}	
					} else {$ret = JText::_('DV_P_CP_GROUPDELETEDFAIL1'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_EMPTYGROUPNO'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mygroups&Itemid='.$itemid, $ret, $type);
				$controller->redirect();
			break;
			case 'editGroup':
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				$ret = '';
				$row =& JTable::getInstance('dv_ugroups', 'Table');
				$row->load($data);
				if ($row->uid == $user->id) {
					if (!$row->image == 0) {
						$image = '<img style="padding:5px 0 0 5px" src="'.JURI::base().'jMediaDirect/videos/pics/groups/'.$user->id.'/'.$row->image.'.png" height="60px"/>';
					} else {$image = '<font color="#ccc">'.JText::_('DV_P_CP_NOIMAGE').'</font>';}
					$script = '<script type="text/javascript">function pwd(id) {if (id == "1") { document.getElementById("password").style.display = "none";} else { document.getElementById("password").style.display = "block";}}
					function clearText (el) { if (el.defaultValue == el.value) el.value = "";el.style.color="#888";}
					function restoreText (el) { if (el.value == "") {el.value = el.defaultValue;el.style.color="#888";}}</script>';	
					$script .= '<script type="text/javascript">function ajaxFunction(uniquename) {
								var xmlHttp; try { xmlHttp=new XMLHttpRequest(); }
								catch (e) { try { xmlHttp=new ActiveXObject("Msxml2.XMLHTTP"); }
								catch (e) { try { xmlHttp=new ActiveXObject("Microsoft.XMLHTTP"); }
								catch (e) { alert("Your browser does not support AJAX!"); return false; } } }
								var url="'.JURI::BASE().'index.php?option=com_jvideodirect&task=checkPermaName&'.JUtility::getToken().'=1&format=raw&t=group&p='.$row->id.'&c=";
								url=url+uniquename;
								xmlHttp.onreadystatechange=function() {
								if(xmlHttp.readyState==4) { var r=xmlHttp.responseText;
								if (r != "") document.getElementById("ajaxResult").innerHTML=r; } }
								xmlHttp.open("GET",url,true);
								xmlHttp.send(null);}</script>';							
					$title = '<input id="gname" type="text" name="gname" value="'.$row->group.'" size="28"/>';
					$desc = '<input id="gdesc" type="text" name="gdesc" value="'.$row->description.'" size="40"/>';
					$accesstypeO = array(0 => JHTML::_('select.option', 1, JText::_('DV_F_PUBLIC') ),JHTML::_('select.option', 0, JText::_('DV_F_PRIVATE') ));															
					$accesstype = helperTools::genericList($accesstypeO, 'accesstype', ' onclick="pwd(this.value);" ', $row->access_type);
					if ($row->pwd) {$row->pwd = 'jVideoDirect';}
					$pwdinput = '<input id="gpwd" type="password" name="gpwd" value="'.$row->pwd.'" onfocus="clearText(this);" onblur="restoreText(this);" size="20" style="color:#888"/>';
					$display = ($row->access_type) ? 'none' : 'block';
					if ($row->status == 'inactive') {$statusCode = '0';} else {$statusCode = ($row->status == 'active') ? '1':'2'; }
					$statusO = array();	
					if ($statusCode == '2') {$statusO[] = JHTML::_('select.option', 2, JText::_('DV_P_CP_SUSPEND'));} else {
					$statusO[] = JHTML::_('select.option', 1, JText::_('DV_P_CP_ACTIVE'));
					$statusO[] = JHTML::_('select.option', 0, JText::_('DV_P_CP_INACTIVE'));
					}
					$status = helperTools::genericList($statusO, 'status', '', $statusCode);
					$atitle = '<input type="text" id="uname" name="uname" size="20" value="'.$row->unique.'" class="inputbox" maxlength="40" onblur="ajaxFunction(this.value);"/>';					
				} else {$ret = '<h4 style="color:red;text-align:center">'.JText::_('DV_P_CP_GROUPNOPERMISSION').'</h4>';}
		
				if (!$ret) {
					$ret = $script.'<div style="display:block;width:300px;margin:0 auto;">
					<form id="editgroup" name="editgroup" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post" enctype="multipart/form-data">';
					$ret .= '<div>'.$image.'</div>						
					   <div style="padding-top:10px">'.JText::_('DV_P_CP_GROUPIMAGE').':</div>
					   <div><input id="gphoto" type="file" name="gphoto"  size="28"/></div>
					   <div style="font-size:0.9em;font-style:italic;">'.JText::_('DV_P_CP_SUPPORTFORMAT').': png , jpg , gif</div>
					   <div style="padding-top:10px">'.JText::_('DV_P_CP_UNIQUENAME').': </div>
					   <div style="height:25px"><div style="float:left;color:#1b44f3;font-size:1.2em;font-weight:bold;">'.$atitle.'</div><div id="ajaxResult" style="padding-left:5px"></div></div>						   
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_GROUPNAME1').': '.$title.'</div>	
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_GROUPDESC1').': '.$desc.'</div>
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_KEYWORDS').': '.$tags.'</div>
					   <div style="font-size:0.9em;float:right"><i>('.JText::_('DV_P_SEPARATOR').')</i></div>
					   <div style="padding-top:15px">'.JText::_('DV_F_ACCESSTYPE').': '.$accesstype.'</div>
					   <div id="password" style="display:'.$display.';">
					   <div style="padding-top:15px;">'.JText::_('DV_P_CP_PASSWORD').': '.$pwdinput.'</div>
					   <div style="padding-top:1px;font-size:0.9em;line-height:13px;">'.JText::_('DV_P_CP_PWDCOMMENT').'</div></div>
					   <div style="padding-top:15px">'.JText::_('DV_P_CP_STATUS').': '.$status.'</div>';
						if ($statusCode == '2') { 
						$ret .= '<div style="font-size:0.9em;color:red;line-height:13px">'.JText::_('DV_P_CP_SUSCOMMENT').'</div>';	
						}	
						$ret .='
					   <input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="saveGroup" />
					   <input name="info" id="info" type="hidden" value="'.$data.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="layout" type="hidden" id="layout" value="9" />
					   <input name="controller" type="hidden" value="userpanel" /><p/>
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></div>';
					}					
				return $ret;
			break;
			case 'saveGroup':
				$messageflag = 0;
				jimport('joomla.filesystem.folder');
				jimport('joomla.filesystem.file');
				jimport('joomla.filesystem.path');
				$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'groups';
				$data = JRequest::getVar('info',$data);
				$unique = helperTools::cleantext(JRequest::getVar('uname',''),false);				
				$title = helperTools::cleantext(JRequest::getVar('gname',''),false);
				$desc = helperTools::cleantext(JRequest::getVar('gdesc',''),false);
				$tags = helperTools::tagStd(JRequest::getVar('gtags',''),false);					
				$srcphoto = JRequest::getVar( 'gphoto', null, 'files', 'array');
				if ($srcphoto['error'] == 0) {
					$fileExt = strtolower(jFile::getExt ($srcphoto['name']));
					if (($fileExt == 'png')||($fileExt == 'jpg')||($fileExt == 'gif')) {
						$name = helperTools::processChImage($srcphoto, $user->id, 2);
						if ($name[1] == true) {
							if (JFile::exists($base.DS.$user->id.DS.$name[0].'.png')) {
							$imageok = true; } else {$imageok = false;} 	
						} else {$ret = JText::_('DV_P_CP_UPLOADERROR'); $type = 'error';}
					} else {$ret = JText::_('DV_P_CP_WRONGFORMAT'); $type = 'error';}
				}
				$row =& JTable::getInstance('dv_ugroups', 'Table');	
				$row->load($data);
				$old = $base.DS.$user->id.DS.$row->image.'.png';
				if ($unique) {
					if ($this->checkUniqueName( $unique, $data, 'group', true)) {
						$db = &JFactory::getDBO();
						$row->unique = $db->getEscaped(helperTools::cleantext($unique));
					} else {$message = JText::_('DV_P_CP_TAKENBEFORESAVE'); JError::raiseWarning( 500, $message);}
				}				
				if ($title) {
					$db = &JFactory::getDBO();
					$row->group = $db->getEscaped(helperTools::cleantext($title));
				}
				if ($desc) {
					$db = &JFactory::getDBO();
					$row->description = $db->getEscaped(helperTools::cleantext($desc));
				}
				$row->tags = $tags;
				if (($srcphoto['error'] == 0) && ($imageok)) {
					$row->image = $name[0];
				}
				$pwd = JRequest::getVar('gpwd','');	
				if ($pwd){if ($pwd != 'jVideoDirect'){$row->pwd = helperTools::cryptpwd($pwd);}}
				$status = JRequest::getVar('status','');					
				if ($status == '0') {$row->status = 'inactive';} else {$row->status = ($status == '1') ? 'active':'suspended'; }	
								
				$row->access_type = JRequest::getVar('accesstype','');
				if (($pwd == null) && ($status == 1) && ($row->access_type == 0)) {
					$messageflag = 1;
					$row->status = 'inactive';				
				}							
				//onplugins group after create and activate group	
				if (($row->status == 'active') && (!$row->acount)) {
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterGroupPublished', array(&$user, &$row) );
				}
				
				if (($row->status == 'active') && (!$row->acount) && ($init->communitySys == 1)) {		
					require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
					$tp = new thirdparties;					
					if ($init->js_userpoint == 1) { $tp->givePoint(31);}
					$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->group, 6);
					if (($init->js_as_creatchannel == 1)&&($row->access_type)) { $tp->stream(31,$row->uid,$jsas);}
					$row->acount = $row->acount + 1;					
				}				
				if ($row->store()) {
					if ($srcphoto['error'] == 0) {
						if (JFile::exists($old)) {JFile::delete($old);}
					}
					$ret = ($messageflag == 1) ? JText::_('DV_P_CP_GROUPUPDATEDBUT') : JText::_('DV_P_CP_GROUPUPDATED');
					$type='';
				} else {$ret = JText::_('DV_P_CP_GROUPUPDATEFAIL'); $type='error';}

				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=mygroups&Itemid='.$itemid, $ret, $type);
				$controller->redirect();					
			break;
			case 'addVideoToGroup':
			case 'addVideoToJGroup':
				if ($task == 'addVideoToGroup') {
					$texttitle = JText::_('DV_P_CH_ADDTOGROUP');
					$taskvalue = 'processVGAdd';
				} else {
					$texttitle = JText::_('DV_P_CH_ADDTOJGROUP');
					$taskvalue = 'processVGAddM';					
				}
				if ($data) {
					$row =& JTable::getInstance('dv_ugroups', 'Table');				
					$row->load($data);	
					$userid = ($task == 'addVideoToGroup') ? $row->uid : $user->id;
					$vlist = helperTools::getVideoListDetails($userid, 'dateadded', 'DESC');											
					$vdoList = helperTools::getVideoList($vlist, '500px', 6, $data);
					$group = '<script type="text/javascript">';
					$group .= ($init->loadjqnoconflict == true) ? "jQuery.noConflict();" : "";
					$group .= 'jQuery(document).ready(function(){
						jQuery("#jobuserUPAG").submit(function(){
						jQuery.ajax({ 
							data: jQuery(this).serialize(),
							type: jQuery(this).attr("post"), 
							url: jQuery(this).attr("action"),
							success: function(response) { 
								jQuery("#ajaxResult").html(response); 
							}});
						return false;});			
						});';					
					$group .= '</script>';					
					$group .= '<div style="font-size: 1.5em; height:28px; padding:8px 25px 0 0;">'.$texttitle.' <font color="#222dbe"><b>'.$row->group.'</b></font></div>
					<div id="ajaxResult"></div>
					<div>		
						<form id="jobuserUPAG" name="jobuserUPAG" method="post" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'">
							<div class="vspacer5">'.$vdoList.'</div>			
				
						<input type="hidden" name="'.JUtility::getToken().'" value="1" />
						<input name="job3" id="job3" type="hidden" value="'.$taskvalue.'" />
						<input name="info3" id="info3" type="hidden" value="" />
						<input name="p" id="p" type="hidden" value="" />
						<input name="format" type="hidden" id="format" value="raw" />
						<input name="task" type="hidden" id="task" value="job" />
						<input name="controller" type="hidden" value="userpanel" />		
						</form>
					</div></div>';		
				}
				echo $group;			
			break;	
			case 'processVGAdd':
			case 'processVGAddM':
				$gid = $playlist;
				if (($gid)||(!$gid==0)||(!$gid=='')) { 
					if (!helperTools::checkFieldExist('vid', $v->id, 'dv_ugroupsitems', 'uid', $user->id, 'gid', $gid)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->vid = $v->id;
						$log->gid = $gid;
						$log->date = $createdate->toFormat();
						if ($task == 'processVGAddM') {
							$log->type = 2;
						}
						$ret = JText::_('DV_P_STOREERROR');$type = 'error';
						if (helperTools::saveVData($log, 'dv_ugroupsitems')) {
							$ret = JText::_('DV_P_SUCCESS_ADDGROUP1');
							
							//onplugins group after add video to group		
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterVideoAddedToGroup', array(&$user,&$v, &$gid) );
							
							if ($init->communitySys == 1) {	
								$row =& JTable::getInstance('dv_ugroups', 'Table');
								$row->load($gid);							
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(35);}
								$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->group, 6);
								if (($init->js_as_assigngroup == 1)&&($row->access_type)&&($row->status == 'active')) { $tp->stream(35,$user->id,$jsas);}				
							}								
						}
					} else {$ret = JText::_('DV_P_VEXISTGROUP1');}
				} else {$ret = JText::_('DV_P_VEMPTYGROUP1');}		
				echo $ret;
			break;
			case 'chooseGroup':		
				$pls = $this->getUserMyGroups($user->id);	
				$parr = array();
				for($i=0;$i<count($pls);$i++) {
					$parr[] = JHTML::_('select.option', $pls[$i]->id, $pls[$i]->group );
				}
				$c = '<table width="350px" align="center" border="0"><tr><td align="center"><form id="vGForm" name="vGForm" action="'.JRoute::_('index.php?option=com_jvideodirect&Itemid='.$itemid ).'" method="post">';
				$c .= '<div>'.JText::_('DV_P_CP_PLFORM').'</div><div>"'.$v->title.'"</div>';
				if (count($pls) == 0) {
					$c .= JText::_('DV_P_CP_TOGROUP') . ' <input class="inputbox" type="text" name="createGroup" id="createGroup" size="20" maxlength="150" />';
				} else {
					$c .= JText::_('DV_P_CP_TOGROUP') . ' ' .helperTools::genericList( $parr, 'addToGroup', null, null );
				}
				$c .= '<input type="hidden" name="'.JUtility::getToken(true).'" value="1" />	
					   <input name="job" id="job" type="hidden" value="addToGroup" />
					   <input name="info" id="info" type="hidden" value="'.$v->id.'" />
					   <input name="task" type="hidden" id="task" value="job" />
					   <input name="layout" type="hidden" id="layout" value="1" />					   
					   <input name="controller" type="hidden" value="userpanel" /><p/>
					   <input type="submit" id="submit" value="'.JText::_('DV_F_SUBMIT').'"/>
					   </form></td></tr></table>';
				return $c;
			break;
			case 'addToGroup':
				$cpl = JRequest::getVar( 'createGroup', null);
                $pL = JRequest::getVar( 'addToGroup', null);	                       
                if ($cpl) {
                	$db = &JFactory::getDBO();
                	$cpl = $db->getEscaped(helperTools::cleantext($cpl));
					$createdate =& JFactory::getDate(time());
					$log='';
					$log->uid = $user->id;
					$log->group = $cpl;
					$log->date = $createdate->toFormat();
					$log->status = 'inactive';
					$ret = JText::_('DV_P_STOREERROR');
					if (helperTools::saveVData($log, 'dv_ugroups')) {
						$q = "SELECT * FROM #__dv_ugroups WHERE uid = '".$user->id."'";
						$db->setQuery( $q );
						$result = $db->loadObject();
						$pL = $result->id;
					}	                
                }
				if (($pL)||(!$pL==0)||(!$pL=='')) {
					if (!helperTools::checkFieldExist('vid', $v->id, 'dv_ugroupsitems', 'uid', $user->id, 'gid', $pL)) {
						$createdate =& JFactory::getDate(time());
						$log='';
						$log->uid = $user->id;
						$log->vid = $v->id;
						$log->gid = $pL;
						$log->date = $createdate->toFormat();
						$ret = JText::_('DV_P_STOREERROR');$type = 'error';
						if (helperTools::saveVData($log, 'dv_ugroupsitems')) {
							$ret = JText::_('DV_P_SUCCESS_ADDGROUP');
							$type = '';
							
							//onplugins group after add video to group	
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterVideoAddedToGroup', array(&$user,&$v, &$pL) );
							
							if ($init->communitySys == 1) {	
								$row =& JTable::getInstance('dv_ugroups', 'Table');
								$row->load($gid);							
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(35);}
								$jsas->p = true;$jsas->vid = $row->id;$jsas->name = helperTools::trimStr($row->group, 6);
								if (($init->js_as_assigngroup == 1)&&($row->access_type)&&($row->status == 'active')) { $tp->stream(35,$user->id,$jsas);}				
							}									
						}
					} else {$ret = JText::_('DV_P_VEXISTGROUP');$type = 'error';}
				} else {$ret = JText::_('DV_P_VEMPTYGROUP');$type = 'error';}	
				$layout = ($layout) ? '&layout='.$layout : '';
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel'.$layout.'&Itemid='.$itemid, $ret, $type);
				$controller->redirect();			
			break;
			case 'deljoinedgroup':
				if ($data) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_groups WHERE gid = '".$data."' AND uid = '".$user->id."'";							
					$db->setQuery( $q );										
					if ($db->query()) {
						$update =& JTable::getInstance('dv_ugroups', 'Table');
						$update->load($data);
						$update->subscribers = $update->subscribers - 1;
						if (helperTools::saveVData($update, 'dv_ugroups')) {
							$ret = JText::_('DV_P_CP_GROUPDELETED'); $type = '';
							
							//onplugins group after leave group				
							$dispatcher =& JDispatcher::getInstance();
							$dispatcher->trigger( 'onAfterGroupLeft', array(&$user,&$update) );

							if ($init->communitySys == 1) {		
								require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
								$tp = new thirdparties;					
								if ($init->js_userpoint == 1) { $tp->givePoint(33);$tp->givePoint(37,$update->uid);}
								$jsas->p = true;$jsas->vid = $update->id;$jsas->name = helperTools::trimStr($update->group, 6);
								if (($init->js_as_leavegroup == 1)&&($update->access_type)) { $tp->stream(33,$user->id,$jsas);}				
							}											
						} else {$ret = JText::_('DV_P_CP_GROUPDELETEDFAIL'); $type = 'error';}						
					} else {$ret = JText::_('DV_P_CP_GROUPDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_EMPTYGROUPNO'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=joinedgroups&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;
			case 'showMyGroup':
			case 'showMyChannel':			
			case 'showJoinedGroup':
			case 'showMyGroupMembers':
			case 'showJoinGroupMembers':
			case 'showMyChannelMembers':
				$session =& JFactory::getSession();		
				switch ($task) {
					case 'showMyGroup':
						$session->set('mgid', $data, 'jvideodirect');	
						$layout = 10;
					break;
					case 'showJoinedGroup':
						$session->set('jgid', $data, 'jvideodirect');	
						$layout = 11;
					break;
					case 'showMyGroupMembers':
						$session->set('gmid', $data, 'jvideodirect');	
						$layout = 12;
					break;
					case 'showJoinGroupMembers':
						$session->set('jmid', $data, 'jvideodirect');	
						$layout = 13;
					break;
					case 'showMyChannel':
						$session->set('mchid', $data, 'jvideodirect');	
						$layout = 8;
					break;						
					case 'showMyChannelMembers':
						$session->set('scid', $data, 'jvideodirect');	
						$layout = 14;
					break;					
				}			
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout='.$layout.'&Itemid='.$itemid);
				$controller->redirect();	
			break;			
			case 'removeFromGroup':
				if ($data) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_ugroupsitems WHERE id = '".$data."' AND uid = '".$user->id."'";
					$db->setQuery( $q );						
					
					//onplugins group after video removed from group	
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoRemovedFromGroup', array(&$user, &$data) );						
					
					if ($db->query()) {
						$ret = JText::_('DV_P_CP_VGROUPDELETED'); $type = '';

						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(39);}
						}							
					} else {$ret = JText::_('DV_P_CP_VGROUPDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_CP_VEMPTYGROUP'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyGroup&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;		
			case 'removeFromJGroup':
				if ($data) {
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_ugroupsitems WHERE id = '".$data."' AND uid = '".$user->id."'";
					$db->setQuery( $q );	

					//onplugins group after video removed from Joined group	
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger( 'onAfterVideoRemovedFromJoinedGroup', array(&$user, &$data) );	
					
					if ($db->query()) {
						$ret = JText::_('DV_P_CP_VGROUPDELETED'); $type = '';					
						if ($init->communitySys == 1) {
							require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
							$tp = new thirdparties;					
							if ($init->js_userpoint == 1) { $tp->givePoint(39);}
						}							
					} else {$ret = JText::_('DV_P_CP_VGROUPDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_CP_VEMPTYGROUP'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showJoinedGroup&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;		
			case 'removeMember':
				if ($data) {
					$row =& JTable::getInstance('dv_groups', 'Table');
					$row->load($data);
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_groups WHERE id = '".$data."'";
					$db->setQuery( $q );						
					if ($db->query()) {
						$q = "DELETE FROM #__dv_ugroupsitems WHERE gid = '".$row->gid."' AND uid = '".$row->uid."'";
						$db->setQuery( $q );						
						if ($db->query()) {
							$update =& JTable::getInstance('dv_ugroups', 'Table');
							$update->load($row->gid);
							$update->subscribers = $update->subscribers - 1;
							if (helperTools::saveVData($update, 'dv_ugroups')) {
								$ret = JText::_('DV_P_CP_GROUPMEMBERDELETED'); $type = '';
								
								//onplugins group after user kickout from group			
								$dispatcher =& JDispatcher::getInstance();
								$dispatcher->trigger( 'onAfterUserKickOutFromGroup', array(&$row, &$update) );


								if ($init->communitySys == 1) {		
									require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
									$tp = new thirdparties;					
									if ($init->js_userpoint == 1) { $tp->givePoint(34,$row->uid);}
									$jsas->p = true;$jsas->vid = $update->id;$jsas->name = helperTools::trimStr($update->group, 6);
									if (($init->js_as_kickoutgroup == 1)&&($update->access_type)) { $tp->stream(34,$row->uid,$jsas);}			
								}								
							} else {$ret = JText::_('DV_P_CP_GROUPMEMBERDELETEDFAIL'); $type = 'error';}	
						} else {$ret = JText::_('DV_P_CP_GROUPMEMBERDELETEDFAIL'); $type = 'error';}		
					} else {$ret = JText::_('DV_P_CP_GROUPMEMBERDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_CP_EMPTYGROUPMEMBER'); $type = 'error';}	
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyGroupMembers&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;
 			case 'removeSubscriber':
				if ($data) {
					$row =& JTable::getInstance('dv_channels', 'Table');
					$row->load($data);
					$db = &JFactory::getDBO();
					$q = "DELETE FROM #__dv_channels WHERE id = '".$data."'";
					$db->setQuery( $q );						
					if ($db->query()) {
						$q = "DELETE FROM #__dv_uchannelsitems WHERE cid = '".$row->cid."' AND uid = '".$row->uid."'";
						$db->setQuery( $q );						
						if ($db->query()) {
							$update =& JTable::getInstance('dv_uchannels', 'Table');
							$update->load($row->cid);
							$update->subscribers = $update->subscribers - 1;
							if (helperTools::saveVData($update, 'dv_uchannels')) {
								$ret = JText::_('DV_P_CP_SUBSCRIBERDELETED'); $type = '';
								
								//onplugins channel after user kickout from channel			
								$dispatcher =& JDispatcher::getInstance();
								$dispatcher->trigger( 'onAfterUserKickOutFromChannel', array(&$row, &$update) );

								if ($init->communitySys == 1) {		
									require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
									$tp = new thirdparties;					
									if ($init->js_userpoint == 1) { $tp->givePoint(24,$row->uid);}
									$jsas->p = true;$jsas->vid = $update->id;$jsas->name = helperTools::trimStr($update->channel, 6);
									if (($init->js_as_kickoutchannel == 1)&&($update->access_type)) { $tp->stream(24,$row->uid,$jsas);}			
								}										
							} else {$ret = JText::_('DV_P_CP_SUBSCRIBERDELETEDFAIL'); $type = 'error';}	
						} else {$ret = JText::_('DV_P_CP_SUBSCRIBERDELETEDFAIL'); $type = 'error';}		
					} else {$ret = JText::_('DV_P_CP_SUBSCRIBERDELETEDFAIL'); $type = 'error';}					   	
				} else {$ret = JText::_('DV_P_CP_EMPTYSUBSCRIBER'); $type = 'error';}					
				$controller = new  jvideodirectController();
				$controller->setRedirect('index.php?option=com_jvideodirect&view=userpanel&layout=showMyChannelMembers&Itemid='.$itemid, $ret, $type);
				$controller->redirect();				
			break;			
			case 'showmemberlist':
				if(($data) && ($playlist)) {
					$row = $this->getMemberlist($data, $playlist);				
					if ($init->communitySys) { require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
						$tp = new thirdparties();			
						$avatarlink = $tp->getuseravatar($row->uid,1);
						$userprofile = $tp->getuserprofile($row->uid);
						$avatar = '<div style="float:left;"><a href="'.$userprofile.'"><img src="'.$avatarlink.'" style="height: 70px;"/></a></div>';		
					}
					$totalv = $this->getMyGroupVideoTotal($row->gid, $row->uid, 2);
					$ret = '<div class="membervlist">'.$avatar.'<div style="float:left"><div class="membervlist1">'.$row->username . '</div><div class="membervlist2"> ' . helperTools::trimStr($row->group, 25).'</div></div><div class="membervlist3">'.JText::_('DV_P_CP_VIDEOCOUNT').': '.$totalv.'</div></div>';
					$ret .= '<div class="separator10"></div>';
					if ($row->oid == $user->id) {
						$list = $this->getMyGroupVideo($row->gid, $row->uid, 2);
						$ret .= helperTools::getVideoList($list, '550px');						
					} else $ret='<div>'.JText::_('DV_P_CP_NOPERMISSION').'</div>';
				} else $ret='<div>'.JText::_('DV_P_CP_NOPERMISSION').'</div>';
				echo $ret;
			break;
			case 'showjmemberlist':
				if(($data) && ($playlist)) {
					$row = $this->getMemberlist($data, $playlist);				
					if ($init->communitySys) { require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
						$tp = new thirdparties();			
						$avatarlink = $tp->getuseravatar($row->uid,1);
						$userprofile = $tp->getuserprofile($row->uid);
						$avatar = '<div style="float:left;"><a href="'.$userprofile.'"><img src="'.$avatarlink.'" style="height: 70px;"/></a></div>';		
					}
					$totalv = $this->getMyGroupVideoTotal($row->gid, $row->uid, 2);
					$ret = '<div class="membervlist">'.$avatar.'<div style="float:left"><div class="membervlist1">'.$row->username . '</div><div class="membervlist2"> ' . helperTools::trimStr($row->group, 25).'</div></div><div class="membervlist3">'.JText::_('DV_P_CP_VIDEOCOUNT').': '.$totalv.'</div></div>';
					$ret .= '<div class="separator10"></div>';
					if ($row->uid == $user->id) {
						$list = $this->getMyGroupVideo($row->gid, $row->uid, 2);
						$ret .= helperTools::getVideoList($list, '550px');						
					} else $ret='<div>'.JText::_('DV_P_CP_NOPERMISSION').'</div>';
				} else $ret='<div>'.JText::_('DV_P_CP_NOPERMISSION').'</div>';
				echo $ret;
			break;
		
		}
	}

	function checkUniqueName( $uname, $id, $t, $retboolean = false) {
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;	
		$bad = '<img src="'.JURI::BASE().'components/com_jvideodirect/themes/'.$init->theme.'/images/cross.png" style="padding-left:5px;margin-top:2px"/>';
		$ret = '<img src="'.JURI::BASE().'components/com_jvideodirect/themes/'.$init->theme.'/images/tick.png" style="padding-left:5px;margin-top:2px"/>';
		$isgood = true;
		$min = ($t == 'channel') ? $init->minPermaChannel : $init->minPermaGroup;
		$regex = '/^[a-z\d_]{'.$min.',30}$/i';
		if (preg_match($regex, $uname)) {			
			$rl = ($t == 'channel') ? $init->permaChannelReserved : $init->permaGroupReserved ; 
			$rls = explode(",",$rl);
			$notInList = true; 
			for ($i=0;$i<count($rls);$i++) {
				if ($rls[$i] == $uname) {
					$ret = $bad .' <font color="red" size="0.8em">'. JText::_('DV_CP_NAMETAKEN').'</font>';
					$isgood = false;
					$notInList = false;
					break;
				}
			}
			if ($notInList) {
				$db = &JFactory::getDBO(); 
				$table = ($t == 'channel') ? 'uchannels' : 'ugroups';
				$q = "SELECT * FROM #__dv_".$table." WHERE `unique` = '".$uname."'";		
				$db->setQuery( $q );
				$res = $db->loadObjectList();
							
				if (count($res)) {
					$ret = $bad .' <font color="red" size="0.8em">'. JText::_('DV_CP_NAMETAKEN').'</font>';
					$isgood = false;
					if ($res[0]->id == $id) {
						$ret = '<img src="'.JURI::BASE().'components/com_jvideodirect/themes/'.$init->theme.'/images/tick.png" style="padding-left:5px;margin-top:2px"/>';
						$isgood = true;
					}
				}
			}				
		} else {
			$ret = $bad .' <font color="red" size="0.8em">'. JText::_('DV_CP_WRONGFORMAT1') . ' '.$min.' ' .JText::_('DV_CP_WRONGFORMAT2').'</font>' ;
			$isgood = false;
		}			
		if ($retboolean) return $isgood; else echo $ret;
	}
	
	function saveOrder($cid, $order) {		
		$row =& JTable::getInstance('dv_playlistitems', 'Table');	
		for( $i=0; $i < count($cid); $i++ ) {
			$row->load( (int) $cid[$i] );
			if ($row->order != $order[$i]) {
				$row->order = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}
		return true;
	}
	
	function reorder($p) {
		$user=&JFactory::getUser();
		$db = &JFactory::getDBO(); 
		$q = "SELECT * FROM #__dv_playlistitems WHERE uid = '".$user->id."' AND playlist='".$p."' ORDER BY `order` ASC";		
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 			
		$row =& JTable::getInstance('dv_playlistitems', 'Table');				
		for ($i=0;$i<count($ret);$i++) {
			$row->load($ret[$i]->id);		
			$row->order = $i+1;
			$row->store();
		}	
	}
	
	function orderupdown($pid, $item, $dir) {
		$user=&JFactory::getUser();
		$db = &JFactory::getDBO(); 
		$q = "SELECT * FROM #__dv_playlistitems WHERE uid = '".$user->id."' AND playlist='".$pid."' ORDER BY `order` ASC";		
		$db->setQuery( $q );
		$ret = $db->loadObjectList(); 		
		$row =& JTable::getInstance('dv_playlistitems', 'Table');				
		for ($i=0;$i<count($ret);$i++) {
			if ($ret[$i]->id == $item) {$itemi = $i;}
			$row->load($ret[$i]->id);		
			$row->order = $i+1;
			$row->store();
		}
		$row->load($item);
		$row->order = ($dir != 1) ? $row->order - 1 : $row->order + 1 ;
		$row->store();
		$itemi = ($dir != 1) ? $itemi - 1 : $itemi + 1 ;
		$row->load($ret[$itemi]->id);
		$row->order = ($dir != 1) ? $row->order + 1 : $row->order - 1 ;
		$row->store();	
	}

	function getorder($v, $i, $n){
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;		
		$pagetotal = count($v);		
		$o = '';
		if ($v > 1) {
			switch ($i) {
				case '0':
					$o .= '<span><img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/uparrow0.png" width="16" height="16" border="0" alt="" /></span>
					<span><a href="#reorder" onclick="document.getElementById(\'job\').value=\'orderdown\';document.getElementById(\'info\').value=\''.$v[$i]->pid.'\';document.jobuser.submit();return false;" title="'.JText::_('DV_P_CP_MOVEDOWN').'">  <img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/downarrow.png" width="16" height="16" border="0" alt="'.JText::_('DV_P_CP_MOVEDOWN').'" /></a></span>					
					<input type="text" name="order[]" size="2" value="'.$v[$i]->order.'" class="text_area" style="text-align: center" /><input type="hidden" name="cid[]" value="'.$v[$i]->pid.'" />';
				break;
				default:
					$o .= '<span><a href="#reorder" onclick="document.getElementById(\'job\').value=\'orderup\';document.getElementById(\'info\').value=\''.$v[$i]->pid.'\';document.jobuser.submit();return false;" title="'.JText::_('DV_P_CP_MOVEUP').'">  <img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/uparrow.png" width="16" height="16" border="0" alt="'.JText::_('DV_P_CP_MOVEUP').'" /></a></span>
					<span><a href="#reorder" onclick="document.getElementById(\'job\').value=\'orderdown\';document.getElementById(\'info\').value=\''.$v[$i]->pid.'\';document.jobuser.submit();return false;" title="'.JText::_('DV_P_CP_MOVEDOWN').'">  <img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/downarrow.png" width="16" height="16" border="0" alt="'.JText::_('DV_P_CP_MOVEDOWN').'" /></a></span>
					<input type="text" name="order[]" size="2" value="'.$v[$i]->order.'" class="text_area" style="text-align: center" /><input type="hidden" name="cid[]" value="'.$v[$i]->pid.'" />';
				break;
				case $pagetotal - 1:
					$o .= '<span><a href="#reorder" onclick="document.getElementById(\'job\').value=\'orderup\';document.getElementById(\'info\').value=\''.$v[$i]->pid.'\';document.jobuser.submit();return false;" title="'.JText::_('DV_P_CP_MOVEUP').'">  <img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/uparrow.png" width="16" height="16" border="0" alt="'.JText::_('DV_P_CP_MOVEUP').'" /></a></span>
					<span><img src="'.JURI::base().'components/com_jvideodirect/themes/'.$init->theme.'/images/downarrow0.png" width="16" height="16" border="0" alt="" /></span>
					<input type="text" name="order[]" size="2" value="'.$v[$i]->order.'" class="text_area" style="text-align: center" /><input type="hidden" name="cid[]" value="'.$v[$i]->pid.'" />';
				break;
		
			}
		} 
		return $o;
	}

	function getChannellist($id) {	
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_uchannels WHERE id = "'.$id.'"';
		$db->setQuery( $q );
		$ret = $db->loadObject(); 		
		return $ret;	
	}

	function getUserSubChannel($userid, $limitstart='', $limit='', $filter_order='date', $filter_order_Dir='DESC') {

		$db =& JFactory::getDBO();
		$q = 'SELECT c.*, n.id as chid, n.channel as chname, n.description, n.image, n.subscribers as ch_subscribers, n.uid as oid, n.unique, u.username as owner, i.vcount FROM #__dv_channels AS c LEFT JOIN #__dv_uchannels AS n ON (c.cid = n.id) LEFT JOIN #__users AS u ON (n.uid = u.id) LEFT OUTER JOIN ( SELECT count( uc.vid ) AS vcount, uc.cid FROM #__dv_uchannelsitems AS uc, #__dv_videos AS vd WHERE uc.vid = vd.id AND vd.published = "1" GROUP BY uc.cid ) AS i ON ( i.cid = n.id) WHERE c.uid = "'.$userid.'" AND n.status = "active" ORDER BY `'.$filter_order.'` '.$filter_order_Dir. ' ';
		if ($limit) {
			$db->setQuery( $q , $limitstart, $limit);
		} else {
			$db->setQuery( $q );		
		}
		$ret = $db->loadObjectList(); 
		
		return $ret;		
	}

	function getSubChannelVideo($cid, $limitstart='', $limit='') {
		$db = &JFactory::getDBO(); 
		$q = "SELECT v . * , c.id AS chid, c.channel AS chname, c.image AS chimage, a.name AS cat_name, a.description AS cat_desc FROM #__dv_videos AS v, #__dv_uchannels AS c, #__dv_uchannelsitems AS i, #__dv_categories AS a WHERE c.id = '".$cid."' AND c.status = 'active' AND c.id = i.cid AND i.vid = v.id AND a.id = v.catid AND v.log = '0' AND v.published = '1' ORDER BY dateadded DESC ";	
			
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();		
		return $ret;
	}

	function getUserMyChannel($userid, $limitstart='', $limit='', $filter_order='date', $filter_order_Dir='DESC') {

		$db =& JFactory::getDBO();
		$q = 'SELECT c. * , u.username, i.vcount FROM #__dv_uchannels AS c LEFT JOIN #__users AS u ON ( c.uid = u.id ) LEFT OUTER JOIN ( SELECT count( uc.vid ) AS vcount, uc.cid FROM #__dv_uchannelsitems AS uc, #__dv_videos AS vd WHERE uc.vid = vd.id AND vd.published = "1" GROUP BY uc.cid ) AS i ON ( i.cid = c.id ) WHERE c.uid = "'.$userid.'" ORDER BY `'.$filter_order.'` '.$filter_order_Dir. ' ';

		if ($limit) {
			$db->setQuery( $q , $limitstart, $limit);
		} else {
			$db->setQuery( $q );		
		}
		$ret = $db->loadObjectList(); 
		
		return $ret;		
	}	
	
	function getMyChannelVideo($id, $limitstart='', $limit='') {
		$u = helperTools::isLogin();
		$db = &JFactory::getDBO(); 
		$q = "SELECT v.*, c.name as cat_name, c.description as cat_desc, u.username, i.cid as ch_id, m.image as ch_image, m.channel as ch_name, i.id as iid FROM #__dv_videos as v, #__dv_categories as c, #__users as u, #__dv_uchannelsitems as i, #__dv_uchannels as m WHERE i.cid = '".$id."' AND v.id = i.vid AND c.id = v.catid AND v.log ='0' AND u.id = '".$u->id."' AND m.id = i.cid AND v.published = '1' ORDER BY v.dateadded DESC ";	
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();
		
		return $ret;
	}
	
	function getChannelItemList($vid, $uid, $limitstart='', $limit='') {
		$db = &JFactory::getDBO(); 
		$q = "SELECT i.*, c.channel, c.image, c.subscribers FROM #__dv_uchannelsitems as i, #__dv_uchannels as c WHERE i.vid = '".$vid."' AND i.uid = '".$uid."' AND c.id = i.cid ORDER BY c.date DESC ";	
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();
		
		return $ret;		
	}
	
	function gettotalchsubscribers($uid) {
		$db = &JFactory::getDBO(); 
		$q = "SELECT sum(subscribers) FROM #__dv_uchannels WHERE uid = '".$uid."'";	
		$db->setQuery( $q );
		$ret = $db->loadResult();
		
		return $ret;				
	}

	function getjoinedgroups($userid, $limitstart='', $limit='', $filter_order='date', $filter_order_Dir='DESC') {

		$db =& JFactory::getDBO();
		$q = 'SELECT c.*, n.access_type, n.group as gname, n.image, n.description, n.subscribers as g_subscribers, n.uid as oid, n.unique, u.username AS owner, i.vcount FROM #__dv_groups AS c LEFT JOIN #__dv_ugroups AS n ON ( c.gid = n.id ) 
		LEFT JOIN #__users AS u ON ( n.uid = u.id ) LEFT OUTER JOIN ( SELECT count( ug.vid ) AS vcount, ug.gid FROM #__dv_ugroupsitems AS ug, #__dv_videos AS vd WHERE ug.uid = "'.$userid.'" AND ug.vid = vd.id AND vd.published = "1" GROUP BY ug.gid ) AS i ON ( i.gid = n.id ) WHERE c.uid = "'.$userid.'" AND n.status = "active" ORDER BY `'.$filter_order.'` '.$filter_order_Dir. ' ';		
		if ($limit) {
			$db->setQuery( $q , $limitstart, $limit);
		} else {
			$db->setQuery( $q );		
		}
		$ret = $db->loadObjectList(); 
		
		return $ret;		
	}	
	
	function getjoingroupsvideo($gid, $limitstart='', $limit='') {
		$db = &JFactory::getDBO(); 
		$q = "SELECT v . * , g.id AS gid, g.group AS gname, g.image AS gimage, a.name AS cat_name, a.description AS cat_desc FROM #__dv_videos AS v, #__dv_ugroups AS g, #__dv_ugroupsitems AS i, #__dv_categories AS a WHERE g.id = '".$gid."' AND g.id = i.gid AND g.status = 'active' AND i.vid = v.id AND a.id = v.catid AND v.log = '0' AND v.published = '1' ORDER BY dateadded DESC ";	
			
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();		
		return $ret;
	}	

	function gettotalgmembers($uid) {
		$db = &JFactory::getDBO(); 
		$q = "SELECT sum(subscribers) FROM #__dv_ugroups WHERE uid = '".$uid."'";	
		$db->setQuery( $q );
		$ret = $db->loadResult();
		
		return $ret;				
	}

	function getgmembers($gid, $limitstart='', $limit='',$filter_order='date', $filter_order_Dir='DESC') {
		$db = &JFactory::getDBO(); 
		$q = "SELECT g.*, u.group, u.access_type, u.image, u.subscribers, j.username, j.name, v.vcount, s.status FROM #__dv_groups AS g, #__dv_ugroups AS u, #__users AS j LEFT OUTER JOIN ( SELECT count(ug.vid) AS vcount, ug.uid FROM #__dv_ugroupsitems AS ug, #__dv_videos AS vd WHERE ug.gid = '".$gid."' AND ug.vid = vd.id AND vd.published = '1' GROUP BY ug.uid ) AS v ON (v.uid = j.id) LEFT OUTER JOIN ( Select count(userid) AS status, userid FROM #__session WHERE guest = '0' ) AS s ON (s.userid = j.id) WHERE g.gid = '".$gid."' AND g.gid = u.id AND g.uid = j.id ORDER BY `".$filter_order."` ".$filter_order_Dir. " ";		
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();
		
		return $ret;				
	}

	function getcmembers($cid, $limitstart='', $limit='',$filter_order='date', $filter_order_Dir='DESC') {
		$db = &JFactory::getDBO(); 
		$q = "SELECT c.*, u.channel, u.access_type, u.image, u.subscribers, j.username, j.name, s.status FROM #__dv_channels AS c, #__dv_uchannels AS u, #__users AS j LEFT OUTER JOIN ( Select count(userid) AS status, userid FROM #__session WHERE guest = '0' ) AS s ON (s.userid = j.id) WHERE c.cid = '".$cid."' AND c.cid = u.id AND c.uid = j.id ORDER BY `".$filter_order."` ".$filter_order_Dir. " ";	
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();
		
		return $ret;				
	}

	function getUserMyGroups($userid, $limitstart='', $limit='', $filter_order='date', $filter_order_Dir='DESC') {

		$db =& JFactory::getDBO();
		$q = 'SELECT c.*, u.username, i.vcount FROM #__dv_ugroups AS c LEFT JOIN #__users AS u ON ( c.uid = u.id ) LEFT OUTER JOIN ( SELECT count( ug.vid ) AS vcount, ug.gid FROM #__dv_ugroupsitems AS ug, #__dv_videos AS vd WHERE ug.uid = "'.$userid.'" AND ug.vid = vd.id AND vd.published = "1" GROUP BY ug.gid ) AS i ON ( i.gid = c.id ) WHERE uid = "'.$userid.'" ORDER BY `'.$filter_order.'` '.$filter_order_Dir. ' ';
		if ($limit) {
			$db->setQuery( $q , $limitstart, $limit);
		} else {
			$db->setQuery( $q );		
		}
		$ret = $db->loadObjectList(); 
		
		return $ret;		
	}
	
	function getMyGroupVideo($gid, $uid=0, $type = 0, $limitstart='', $limit='') {
		$u = helperTools::isLogin();
		
		Switch ($type) {
			case '0': $type = ''; break;
			case '1': case '2': $type = " AND i.type = '".$type."' AND i.uid = '".$uid."' "; break;
		}
		$db = &JFactory::getDBO();
		$q = "SELECT v.*, c.name as cat_name, c.description as cat_desc, u.username, i.gid as g_id, m.image as gimage, m.group as gname, m.access_type, i.id as iid FROM #__dv_videos as v, #__dv_categories as c, #__users as u, #__dv_ugroupsitems as i, #__dv_ugroups as m WHERE i.gid = '".$gid."'".$type."AND v.id = i.vid AND c.id = v.catid AND v.log ='0' AND u.id = '".$u->id."' AND m.id = i.gid AND v.published = '1' ORDER BY v.dateadded DESC ";		
		if ($limit) {
			$db->setQuery( $q, $limitstart, $limit );		
		} else {
			$db->setQuery( $q );
		}
		$ret = $db->loadObjectList();
		
		return $ret;
	}

	function getMyGroupVideoTotal($gid, $uid=0, $type=0) {
		Switch ($type) {
			case '0': $type = ''; break;
			case '1': case '2': $type = " AND u.type = '".$type."' AND u.uid = '".$uid."' "; break;
		}	
		$db = &JFactory::getDBO(); 
		$q = "SELECT count(u.vid) FROM #__dv_ugroupsitems AS u, #__dv_videos AS v WHERE u.gid = '".$gid."'".$type." AND u.vid = v.id AND v.published = '1' ";	
		$db->setQuery( $q );
		$ret = $db->loadResult();
		
		return $ret;			
	}

	function getMyChannelVideoTotal($cid) {
		$db = &JFactory::getDBO(); 
		$q = "SELECT count(u.vid) FROM #__dv_uchannelsitems AS u, #__dv_videos AS v WHERE u.cid = '".$cid."' AND u.vid = v.id AND v.published = '1' ";	
		$db->setQuery( $q );
		$ret = $db->loadResult();
		return $ret;			
	}
	
	function getGrouplist($id) {	
		$db =& JFactory::getDBO();
		$q = 'SELECT * FROM #__dv_ugroups WHERE id = "'.$id.'"';
		$db->setQuery( $q );
		$ret = $db->loadObject(); 		
		return $ret;	
	}
	
	function getMemberlist($gid, $uid) {	
		$db =& JFactory::getDBO();
		$q = 'SELECT a.*, b.group, b.uid AS oid, c.username FROM #__dv_groups AS a, #__dv_ugroups AS b, #__users AS c WHERE a.gid = "'.$gid.'" AND a.uid = "'.$uid.'" AND b.id = a.gid AND a.uid = c.id';
		$db->setQuery( $q );
		$ret = $db->loadObject(); 		
		return $ret;	
	}

	function getMembervlist($cid, $uid) {	
		$db =& JFactory::getDBO();
		$q = 'SELECT a.*, b.channel, b.uid AS oid, c.username FROM #__dv_channels AS a, #__dv_uchannels AS b, #__users AS c WHERE a.cid = "'.$cid.'" AND a.uid = "'.$uid.'" AND b.id = a.cid AND a.uid = c.id';
		$db->setQuery( $q );
		$ret = $db->loadObject(); 		
		return $ret;	
	}	
	
	function newThumbm($vid, $src, $upload = false) {	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;	
		$flag = true;
		if ($upload == true) {
			$temp = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'temp'.DS.$src['name'];
			if (JFile::upload($src['tmp_name'], $temp)) {	
				$src = $temp;
			} else {
				$flag = false;
				$ret['ok'] = 0;
				$ret['msg'] = JText::_('DV_F_THUMBUPLOADERROR');
			}
		}
		if ($flag == true) {
			$ret = helperTools::makeNewVThumbNail($vid, $vid, $src);
		}
		return $ret;
	}		
}	
