<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelVideomanagement extends JModel
{
	function __construct(){
		parent::__construct();
		global $mainframe, $option;
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'v'.'filter_order', 'filter_order','dateadded',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'v'.'filter_order_Dir',	'filter_order_Dir',	'desc',	'word' );		
		$limit	= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);		
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);	
		if ($cid) {
			$this->_id = $cid[0];	
		}
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	
	function getTypename() {
		$t = JRequest::getVar( 't', '' );	
		$id = JRequest::getVar( 'id', '' );		
		$table = ($t == 1) ? 'dv_uchannels' : 'dv_ugroups';
		$c =& JTable::getInstance($table, 'Table');
		$c->load($id);
		if ($t == 1) { return $c->channel; } else {return $c->group;}
	}
	
	function getTotal() {
		if (empty($this->_total)) {
			$query = "SELECT * FROM #__dv_videos ORDER BY dateadded DESC ";
			$this->_total = $this->_getListCount($query);			
		}
		return $this->_total;
	}

	function getTotalType() {
		$t = JRequest::getVar( 't', '' );
		$id = JRequest::getVar( 'id', '' );	
		if (!$t) {
			$session =& JFactory::getSession();
			$t = $session->get('t', '', 'jvideodirect');
			$id = $session->get('id', '', 'jvideodirect');		
		}		
		$table = ($t == 1) ? ', #__dv_uchannelsitems AS t ' : ', #__dv_ugroupsitems AS t ';
		$where = ($t == 1) ? ' WHERE t.cid = "'.$id.'" AND v.id = t.vid ' : ' WHERE t.gid = "'.$id.'" AND v.id = t.vid ';	
		if (empty($this->_total)) {
			$query = "SELECT v.* FROM #__dv_videos AS v ".$table." ".$where;
			$this->_total = $this->_getListCount($query);			
		}
		return $this->_total;
	}
	
	function getData() {
		if ($this->getState('filter_order') == 'catid') {
			if (empty($this->_data)) {
				$query = "SELECT v.*, c.name as catname FROM #__dv_videos as v, #__dv_categories as c WHERE v.catid = c.id  ORDER BY v.". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
				$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			}
		} else {
			if (empty($this->_data)) {
				$query = "SELECT v.*, c.name as catname FROM #__dv_videos as v, #__dv_categories as c WHERE v.catid = c.id  ORDER BY ". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
				$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			}		
		}
		return $this->_data;
	}
	
	function getDataType() {
		$t = JRequest::getVar( 't', '' );
		$id = JRequest::getVar( 'id', '' );	
		if (!$t) {
			$session =& JFactory::getSession();
			$t = $session->get('t', '', 'jvideodirect');
			$id = $session->get('id', '', 'jvideodirect');		
		}		
		$table = ($t == 1) ? ', #__dv_uchannelsitems AS t ' : ', #__dv_ugroupsitems AS t ';
		$where = ($t == 1) ? ' AND t.cid = "'.$id.'" AND v.id = t.vid ' : ' AND t.gid = "'.$id.'" AND v.id = t.vid ';
		if ($this->getState('filter_order') == 'catid') {
			if (empty($this->_data)) {
				$query = "SELECT v.*, c.name as catname FROM #__dv_videos as v, #__dv_categories as c ".$table." WHERE v.catid = c.id ".$where." ORDER BY v.". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
				$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			}
		} else {
			if (empty($this->_data)) {
				$query = "SELECT v.*, c.name as catname FROM #__dv_videos as v, #__dv_categories as c ".$table." WHERE v.catid = c.id ".$where." ORDER BY ". $this->getState('filter_order') ." ". $this->getState('filter_order_Dir');
				$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			}
		
		}
		return $this->_data;
	}	
	
	function getOrder() {
		$lists['order_Dir'] = $this->getState('filter_order_Dir');
		$lists['order'] = $this->getState('filter_order');
		return $lists;
	}
	
	function saveCData($data, $table, $id=0) {
		$row =& JTable::getInstance($table, 'Table');		
		if (!$id == 0) {
			$row->load($id);
			}
		
		if (!$row->bind($data)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		return true;
	}

	function publish($cid = array(), $publish = 1) {	
		if (count( $cid )) {
			$date = '';
			if ($publish == 1) {
				$createdate =& JFactory::getDate(time());
				$now = $createdate->toFormat();	
				$date = ', checkeddate = "'.$now.'" '; 
			}
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__dv_videos'
				. ' SET published = '.(int) $publish
				. ' ' .$date. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	function feature($cid = array(), $feature = 1) {	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');
		$init = new initjVideoDirect;		
		
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );		
			$query = 'UPDATE #__dv_videos'
				. ' SET featured = '.(int) $feature
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			//onplugins video after feature / unfeatured a video				
			if ($init->communitySys == 1) {
				$row =& JTable::getInstance('dv_videos', 'Table');
				$row->load($cid[0]);
				require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
				$tp = new thirdparties;					
				if ($init->js_userpoint == 1) { 
					$code = ($feature == 1) ? '734' : '733';
					$tp->givePoint($code, $row->userid);
				}
				$jsas->p = true;$jsas->vid = $row->vname;$jsas->name = viewTools::trimStr($row->title, 6);
				$choice = ($feature == 1) ? $init->js_as_video_feature : $init->js_as_video_unfeature;
				$code = ($feature == 1) ? '734' : '733';				
				if (($choice == 1)&&($row->accesstype)) { $tp->stream($code,$row->userid,$jsas);}								
			}				

		}
		return true;
	}

	function check($cid = array(), $check = 1) {	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');
		$init = new initjVideoDirect;		
		if (count( $cid )) {
			$createdate =& JFactory::getDate(time());
			$date = $createdate->toFormat();			
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			if ($check == 0) $date=0;
			$query = 'UPDATE #__dv_videos'
				. ' SET checked = '.(int) $check
				. ', checkeddate="'.$date.'" WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}			
		}
		return true;
	}

	function getreporters($id) {

		$db =& JFactory::getDBO();
		$q = "SELECT a.*, u.username FROM #__dv_log_abuse AS a LEFT JOIN #__users AS u ON ( a.uid = u.id ) WHERE a.vid = '".$id."' ORDER BY a.date DESC";	
		$db->setQuery( $q );
		$rows = $db->loadObjectlist(); 				
		if (count($rows)){
			$r = '<br/><b><u>'.JText::_('Reported by').'</u></b><br/>';
			for($i=0;$i<count($rows);$i++) {
				$date =& JFactory::getDate($rows[$i]->date);
				$r .= $date->toFormat(JTEXT::_('DATE_FORMAT_JVD')).' '.$rows[$i]->username.' ('.$rows[$i]->uid.') <br/>'.$rows[$i]->comment.'<p/>';
			}
		}		
		return $r;	
	}
	
	function getTaskstats()	{
		$ret = array();
		$db =& JFactory::getDBO();
		$q = "SELECT count(*) FROM #__dv_videos WHERE published = '1'";
		$db->setQuery( $q );
		$ret['live'] = $db->loadResult(); 		
		$q = "SELECT count(*) FROM #__dv_videos WHERE totalabuse != '0'";
		$db->setQuery( $q );
		$ret['abuse'] = $db->loadResult(); 		
		$q = "SELECT count(*) FROM #__dv_videos WHERE published = '0'";
		$db->setQuery( $q );
		$ret['published'] = $db->loadResult(); 		
		$q = "SELECT count(*) FROM #__dv_videos WHERE featured = '1'";
		$db->setQuery( $q );
		$ret['featured'] = $db->loadResult(); 		
		$q = "SELECT count(*) FROM #__dv_videos WHERE status != 'done'";
		$db->setQuery( $q );
		$ret['status'] = $db->loadResult(); 	
		$q = "SELECT count(*) FROM #__dv_videos WHERE hd != '0'";
		$db->setQuery( $q );
		$ret['hdcount'] = $db->loadResult(); 
		return $ret;
	}

	function getselectedvideo($cids) {
		$db =& JFactory::getDBO();
		$cid = explode(',',$cids);
		$where = array();
		for ($i=0;$i<count($cid);$i++) {
			$where[] = ' id = "'.$cid[$i].'" ';
		}
		$wheres = implode(' or ', $where);			
		$q = "SELECT * from #__dv_videos where ".$wheres;
		$db->setQuery( $q );	
		$ret = $db->loadObjectlist();
		return $ret;
	}
	
	function newThumb($id, $time) {	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');
		$init = new initjVideoDirect;	
		$row =& JTable::getInstance('dv_videos', 'Table');
		$row->load($id);		
		$ret = viewTools::makeNewThumbNail($row, $time, $init);
		return $ret;
	}

	function newThumbm($id, $src, $upload = false) {	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;	
		$flag = true;
		if ($upload == true) {
			$temp = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'temp'.DS.$src['name'];
			if (JFile::upload($src['tmp_name'], $temp)) {	
				$src = $temp;
			} else {
				$flag = false;
				$ret['ok'] = 0;
				$ret['msg'] = JText::_('Upload Error !');
			}
		}
		if ($flag == true) {
			$row =& JTable::getInstance('dv_videos', 'Table');
			$row->load($id);		
			$ret = viewTools::makeNewThumbNailm($id, $row->vid, $src);
		}
		return $ret;
	}	
	
}
?>
